#include "AboutDialog.h"


/** CLASSE AboutDialog: FOX's MACROS **/

/* Macro, message map:
 *  - message type: what appened;
 *  - message id: source;
 *  - message handler: what to do.
 */
FXDEFMAP(AboutDialog) AboutDialogMap[]={
   //_________Message_Type_____________________ID__________________________Message_Handler_______________
   //FXMAPFUNC(   SEL_COMMAND,           AboutDialog::ID_PREFCLR,      AboutDialog::onCmdDelPref      )
};


/* Macro, message map implementation:
 *  - 1, the name of the class;
 *  - 2, the name of the parent class;
 *  - 3, pointer to message map;
 *  - 4, no. of messages in message map.
 */
FXIMPLEMENT(AboutDialog, FXDialogBox, AboutDialogMap, ARRAYNUMBER(AboutDialogMap))




/** CLASSE AboutDialog: COSTRUTTORE E DISTRUTTORE **/

/* This function builds the window:
 *  - 1, pointer to the FXWindow owner;
 *  - 2, the window title;
 *  - 5, window decorations;
 *  - 6, initial position, w;
 *  - 7, initial position, h;
 *  - 8, initial size, w;
 *  - 9, initial size, h.
 */
AboutDialog::AboutDialog(FXWindow* owner, FXIcon *_iconsBig[], FXIcon *_iconsSmall[]) : FXDialogBox(owner, "About ShapeConverter", DECOR_TITLE|DECOR_CLOSE|DECOR_BORDER, 0, 0, 400, 300, 0,0,0,0) {
    //Here we can build the window

    /// Icons
    iconsBig=_iconsBig;
    iconsSmall=_iconsSmall;
    setIcon(iconsBig[ICON_WINDOW]);
    setMiniIcon(iconsSmall[ICON_WINDOW]);


    /// Dialog frame
    dialogFrame=new FXVerticalFrame(this, LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 5,5, 5,5, 0,0);
        /// Upper frame
        upperFrame=new FXHorizontalFrame(dialogFrame, LAYOUT_CENTER_X,0,0,0,0, 5,5, 5,5, 5,5);
        new FXLabel(upperFrame, "",iconsBig[ICON_ABOUT], ICON_BEFORE_TEXT,0,0,0,0, 10,10, 10,10);
        new FXLabel(upperFrame, "ShapeConverter - release 4.1\n"
                                "An open source software for converting\n"
                                "Microsoft Train Simulator shape files.\n"
                                " 2009 G.F. stradeferrate@altervista.org\n"
                                "See 'licence.txt' file for licence details.",
                                NULL, LAYOUT_FILL_X,0,0,0,0, 10,10, 10,10);
        new FXSeparator(dialogFrame);//, 0,0,0,0,0,0,5,5);
        new FXLabel(dialogFrame, "REMEMBER: you must ask permission to the 3d Author before converting it!", NULL, JUSTIFY_LEFT|LAYOUT_CENTER_X,0,0,0,0, 10,10, 5,5);
        new FXSeparator(dialogFrame);//, 0,0,0,0,0,0,5,5);
        /// Middle frame
        middleFrame=new FXHorizontalFrame(dialogFrame, LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 5,5, 5,5, 5,5);
        new FXLabel(middleFrame, "Writed with 'Code::Blocks' IDE, compiled with 'MinGW'\n"
                                 "GUI library: FOX Toolkit 1.6.\n"
                                 "Icons:\n"
                                 " - RedCons, GreenCons, SmokeCons by http://mouserunner.com ;\n"
                                 " - FamFamFam by Mark James, http://www.famfamfam.com/lab/icons/silk ;\n"
                                 " - Nuvola Icon Theme by David Vignoni, http://www.icon-king.com ;\n"
                                 " - Nuove XT by Alexandre Moore, http://nuovext.pwsp.net/ ;\n",
                                 NULL, JUSTIFY_LEFT,0,0,0,0, 10,10, 5,5);
        new FXSeparator(dialogFrame);//, 0,0,0,0,0,0,5,5);
        /// Lower frame
        lowerFrame=new FXHorizontalFrame(dialogFrame, LAYOUT_FILL_Y|LAYOUT_CENTER_X,0,0,0,0, 5,5, 10,0, 5,0);
        new FXButton(lowerFrame, "OK", NULL, this, FXDialogBox::ID_ACCEPT, BUTTON_NORMAL|LAYOUT_CENTER_X,0,0,0,0,30,30,5,5);

    /// End of AboutDialog
}

/* Distruttore:
 *  - only MenuPanes, Cursors, Fonts, Images, Icons, Bitmaps, and Visuals.
 *  - see 'http://www.fox-toolkit.com/faq.html#DELETINGSTUFF'.
 */
AboutDialog::~AboutDialog() {
    //Nothing to do (icons belong to MyWindow class)
}




/** CLASSE AboutDialog: CALLBACKS functions **/

/* None:
 *  - no comment.
 */
/*long AboutDialog::onCmdOutCheckBtn(FXObject *sender, FXSelector sel, void *ptr) {
    return 1;
}*/
