#include "AddFileDialog.h"


/** CLASSE AddFileDialog: FOX's MACROS **/

/* Macro, message map:
 *  - message type: what appened;
 *  - message id: source;
 *  - message handler: what to do.
 */
FXDEFMAP(AddFileDialog) AddFileDialogMap[]={
   //_________Message_Type_____________________ID__________________________Message_Handler_______________
   FXMAPFUNC(   SEL_COMMAND,           AddFileDialog::ID_DKTDIR,          AddFileDialog::onCmdBrowseBtn ),
   FXMAPFUNC(   SEL_COMMAND,           AddFileDialog::ID_DOCDIR,          AddFileDialog::onCmdBrowseBtn ),
   FXMAPFUNC(   SEL_COMMAND,           AddFileDialog::ID_CHKALL,          AddFileDialog::onCmdSelectBtn ),
   FXMAPFUNC(   SEL_COMMAND,           AddFileDialog::ID_UNCHKALL,        AddFileDialog::onCmdSelectBtn ),
   FXMAPFUNC(   SEL_SELECTED,          AddFileDialog::ID_DIRLIST,         AddFileDialog::onCmdDirList   ),
   FXMAPFUNC(   SEL_DOUBLECLICKED,     AddFileDialog::ID_CHECKLIST,       AddFileDialog::onCmdCheckList ),
   FXMAPFUNC(   SEL_COMMAND,           AddFileDialog::ID_CHANGEDIR,       AddFileDialog::onCmdChangeDir ),
   FXMAPFUNC(   SEL_COMMAND,           AddFileDialog::ID_ADDPREFDIR,      AddFileDialog::onCmdAddPrefDir)
};


/* Macro, message map implementation:
 *  - 1, the name of the class;
 *  - 2, the name of the parent class;
 *  - 3, pointer to message map;
 *  - 4, no. of messages in message map.
 */
FXIMPLEMENT(AddFileDialog, FXDialogBox, AddFileDialogMap, ARRAYNUMBER(AddFileDialogMap))




/** CLASSE AddFileDialog: COSTRUTTORE E DISTRUTTORE **/

/* This function builds the window:
 *  - 1, pointer to the FXWindow owner;
 *  - 2, the window title;
 *  - 5, window decorations;
 *  - 6, initial position, w;
 *  - 7, initial position, h;
 *  - 8, initial size, w;
 *  - 9, initial size, h.
 */
AddFileDialog::AddFileDialog(FXWindow* owner, FXIcon *_iconsBig[], FXIcon *_iconsSmall[], Options *_opt) : FXDialogBox(owner, "Add files to list", DECOR_TITLE|DECOR_CLOSE|DECOR_BORDER, 0, 0, 400, 300, 0,0,0,0) {
    //Here we can build the window
    /// Inizializzazioni
    selected=0;
    options=_opt;

    /// Icons
    iconsBig=_iconsBig;
    iconsSmall=_iconsSmall;
    setIcon(iconsBig[ICON_WINDOW]);
    setMiniIcon(iconsSmall[ICON_WINDOW]);
    //iconYes=new FXGIFIcon(getApp(), icon_accept_gif);
    //iconNo=new FXGIFIcon(getApp(), icon_cancel_gif);
    //iconYes->create();
    //iconNo->create();

    /// Dialog frame
    dialogFrame=new FXVerticalFrame(this, LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 0,0, 0,0, 0,0);
        /// Main frame
        mainFrame=new FXHorizontalFrame(dialogFrame, LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 5,5, 5,5, 5,5);
            /// Left frame
            leftFrame=new FXVerticalFrame(mainFrame, LAYOUT_FILL_Y|LAYOUT_FIX_WIDTH|FRAME_RAISED,0,0,200,0, 5,5, 5,5, 5,5);
                /// Label
                titleDir=new FXLabel(leftFrame, "Choose a folder", NULL, LAYOUT_CENTER_X);
                /// DirList
                dirList=new FXDirList(leftFrame, this,AddFileDialog::ID_DIRLIST,TREELIST_SHOWS_LINES|TREELIST_SHOWS_BOXES|TREELIST_ROOT_BOXES|TREELIST_BROWSESELECT|FRAME_THICK|LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0);
                /// Buttons
                leftBtnFrame=new FXHorizontalFrame(leftFrame, LAYOUT_CENTER_X,0,0,0,0, 0,0, 0,0, 5,5);
                dktDirBtn=new FXButton(leftBtnFrame, "\tGo to the desktop folder\tGo to the desktop folder", iconsBig[ICON_DESKTOP], this, AddFileDialog::ID_DKTDIR, BUTTON_NORMAL,0,0,0,0,2,2,2,2);
                docDirBtn=new FXButton(leftBtnFrame, "\tGo to your documents folder\tGo to your documents folder", iconsBig[ICON_DOCUMENTS], this, AddFileDialog::ID_DOCDIR, BUTTON_NORMAL,0,0,0,0,2,2,2,2);
                /// Recent folders button
                    /// Recent folders menu
                    recentMenu=new FXMenuPane(this, POPUP_SHRINKWRAP); // POPUP_SHRINKWRAP permette di adattare la larghezza al contenuto anche creando runtime le voci del menu
                        new FXLabel(recentMenu, "Recent folders:", NULL, LAYOUT_CENTER_X);
                        new FXMenuSeparator(recentMenu);
                        if(options->recentInputPaths.size()==0) {
                            noItems=new FXLabel(recentMenu, "None", NULL, LAYOUT_CENTER_X);
                            noItems->disable();
                        }
                        else {
                            unsigned recents=options->recentInputPaths.size();
                            for(unsigned i=0; i<recents; i++) {
                                new FXMenuCommand(recentMenu, options->recentInputPaths[i], iconsSmall[ICON_FOLDER_CLOCK], this, AddFileDialog::ID_CHANGEDIR);
                            }
                        }
                recentBtn=new FXMenuButton(leftBtnFrame,"\tChoose one of the recent folders\tChoose one of the recent folders",iconsBig[ICON_RECENTS],recentMenu,MENUBUTTON_UP|FRAME_RAISED|FRAME_THICK|ICON_AFTER_TEXT,0,0,0,0,2,2,2,2);
                /// Pref folders button
                FXHorizontalFrame *temp=new FXHorizontalFrame(leftBtnFrame, LAYOUT_CENTER_X,0,0,0,0, 0,0, 0,0, 0,0);
                    /// Pref folders menu
                    prefMenu=new FXMenuPane(this, POPUP_SHRINKWRAP); // POPUP_SHRINKWRAP permette di adattare la larghezza al contenuto anche creando runtime le voci del menu
                        new FXLabel(prefMenu, "Pref folders:", NULL, LAYOUT_CENTER_X);
                        new FXMenuSeparator(prefMenu);
                        if(options->prefInputPaths.size()==0) {
                            noItems=new FXLabel(prefMenu, "None", NULL, LAYOUT_CENTER_X);
                            noItems->disable();
                        }
                        else {
                            unsigned prefs=options->prefInputPaths.size();
                            for(unsigned i=0; i<prefs; i++) {
                                new FXMenuCommand(prefMenu, options->prefInputPaths[i], iconsSmall[ICON_FOLDER_STAR], this, AddFileDialog::ID_CHANGEDIR);
                            }
                        }
                prefBtn=new FXMenuButton(temp,"\tChoose one of your favourte folders\tChoose one of your favourite folders",iconsBig[ICON_PREFS],prefMenu,MENUBUTTON_UP|FRAME_RAISED|FRAME_THICK|MENUBUTTON_NOARROWS,0,0,0,0,2,2,2,2);
                    /// Pref folders edit menu
                    prefEditMenu=new FXMenuPane(this);
                        new FXLabel(prefEditMenu, "Edit pref folders:", NULL, LAYOUT_CENTER_X);
                        new FXMenuSeparator(prefEditMenu);
                        addPrefDir=new FXMenuCommand(prefEditMenu, "Add current folder", iconsSmall[ICON_FOLDER_ADD], this, AddFileDialog::ID_ADDPREFDIR);
                        addPrefDir->disable();
                prefEditBtn=new FXMenuButton(temp,"",NULL,prefEditMenu,MENUBUTTON_RIGHT|FRAME_RAISED|FRAME_THICK|TEXT_OVER_ICON|LAYOUT_FILL_Y,0,0,0,0,2,2,0,0);
            /// Right frame
            rightFrame=new FXVerticalFrame(mainFrame, LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_RAISED,0,0,0,0, 5,5, 5,5, 5,5);
                /// Label
                titleCheck=new FXLabel(rightFrame, "Select one or more files", NULL, LAYOUT_CENTER_X);
                titleCheck->disable();
                /// File checkList
                checkList=new FXIconList(rightFrame, this, AddFileDialog::ID_CHECKLIST, LIST_SINGLESELECT|LAYOUT_FILL_X|LAYOUT_FILL_Y);
                checkList->appendHeader("File", NULL,160); //NULL  l'icona
                /// Buttons
                rightBtnFrame=new FXHorizontalFrame(rightFrame, LAYOUT_CENTER_X,0,0,0,0, 0,0, 0,0, 5,5);
                chkAllBtn=new FXButton(rightBtnFrame, "Select all", NULL, this, AddFileDialog::ID_CHKALL, BUTTON_NORMAL,0,0,0,0,10,10,5,5);
                unchkAllBtn=new FXButton(rightBtnFrame, "Unselect all", NULL, this, AddFileDialog::ID_UNCHKALL, BUTTON_NORMAL,0,0,0,0,10,10,5,5);
                chkAllBtn->disable();
                unchkAllBtn->disable();
        /// Lower frame
        lowerFrame=new FXHorizontalFrame(dialogFrame, LAYOUT_FILL_X,0,0,0,0, 5,5, 5,5, 5,5);
            /// Buttons
            addCheckedBtn=new FXButton(lowerFrame, "Add selected", NULL, this, FXDialogBox::ID_ACCEPT, BUTTON_NORMAL|LAYOUT_RIGHT,0,0,0,0,10,10,5,5);
            cancelBtn=new FXButton(lowerFrame, "Cancel", NULL, this, FXDialogBox::ID_CANCEL, BUTTON_NORMAL|LAYOUT_RIGHT,0,0,0,0,10,10,5,5);

    /// End of AddFileDialog



    /// Initial directory
    //NB: il secondo argomento, pari a true, obbliga a lanciare il messaggio (notify) per eseguire la callback
    // per cercare i files nella cartella. Per questo va messa alla fine del costruttore (altrimenti la callback
    // utilizza dei puntatori non inizializzati)
    if(options->recentInputPaths.size()>0) dirList->setDirectory( options->recentInputPaths[0], true );
}

/* Distruttore:
 *  - only MenuPanes, Cursors, Fonts, Images, Icons, Bitmaps, and Visuals.
 *  - see 'http://www.fox-toolkit.com/faq.html#DELETINGSTUFF'.
 */
AddFileDialog::~AddFileDialog() {
    //Nothing to do (icons belong to MyWindow class)
    delete recentMenu;
    delete prefMenu;
    delete prefEditMenu;
}




/** CLASSE AddFileDialog: CALLBACKS functions **/

/* Gestore dei pulsanti della lista delle cartelle:
 *  - apre la cartella documenti o desktop dell'utente.
 */
long AddFileDialog::onCmdBrowseBtn(FXObject *sender, FXSelector sel, void *ptr) {
    FXString dir;
    //Chiede a Windows il percorso
    switch(FXSELID(sel)) {
        case AddFileDialog::ID_DKTDIR:
            win::getDirPath(dir, win::DIR_DESKTOP);
            break;
        case AddFileDialog::ID_DOCDIR:
            win::getDirPath(dir, win::DIR_DOCUMENTS);
            break;
        default:
            return 1;
    }
    //Assegna la cartella e richiede la ricerca files
    dirList->setDirectory( dir, true );
    return 1;
}


/* Gestore dei pulsanti della lista dei files:
 *  - seleziona/deseleziona tutti i file trovati nella cartella.
 */
long AddFileDialog::onCmdSelectBtn(FXObject *sender, FXSelector sel, void *ptr) {
    unsigned lung=checkList->getNumRows();
    switch( FXSELID(sel) ) {
        case AddFileDialog::ID_CHKALL:
            for(unsigned i=0; i<lung; i++) {
                changeFileStat(i, true);
            }
            break;
        case AddFileDialog::ID_UNCHKALL:
            for(unsigned i=0; i<lung; i++) {
                changeFileStat(i, false);
            }
            break;
    }
    return 1;
}


/* Gestore della directory list:
 *  - quando l'utente ha selezionato una cartella che  aperta, vengono cercati tutti i files shape
 *    presenti all'interno di essa (tramite l'api di win);
 *  - se non ci sono files/errore in lettura => scrive un messaggio di errore nella lista e disabilita
 *    lista e buttons;
 *  - se ha trovato dei files, li scrive nella lista (solo il nome) e li aggiunge al vettore
 *    filesInFolder aggiungendo la flag 'false' ad indicare che non  stato ancora selezionato; quindi
 *    abilia buttons e lista.
 */
long AddFileDialog::onCmdDirList(FXObject *sender, FXSelector sel, void *ptr) {
    if(ptr==NULL) return 1;
    FXDirItem *dirItem=(FXDirItem*)ptr;
    if(dirItem->isOpened()) {
        //L'utente ha selezionato una cartella che  aperta => cerca tutti i file shape della cartella
        vector<FXString> searchInFolder;
        int result=win::findAllFiles(dirList->getDirectory(), &searchInFolder, "\\*.s");
        //Attiva il comando del menu preferiti
        addPrefDir->enable();
        //Pulisce la lista dei files
        checkList->clearItems();
        //Scrive la lista dei files della cartella corrente
        if(result<=0) {
            //Errore durante la lettura della cartella / nessun file trovato
            if(result<0) checkList->appendItem("Error! Can't open this folder.", NULL, iconsSmall[ICON_CANCEL_RED]);
            else checkList->appendItem("No shape files in this folder.", NULL, iconsSmall[ICON_EXLAMATION_GRAY]);
            //Disattiva i due buttons
            chkAllBtn->disable();
            unchkAllBtn->disable();
            //Disttiva la lista
            checkList->disable();
            titleCheck->disable();
        }
        else if(result>0) {
            //Ha trovato uno o pi files
            //Pulisce la lista
            filesInFolder.clear();
            //Li aggiunge alla lista
            int m=searchInFolder.size();
            for(int i=0; i<m; i++) {
                checkList->appendItem(FXPath::name(searchInFolder[i]), NULL, iconsSmall[ICON_BLANK_GRAY]);
                //checkList->appendItem(FXPath::name(searchInFolder[i]), NULL, NULL);
                OneFile oneFile;
                oneFile.name=searchInFolder[i];
                oneFile.add=false;
                filesInFolder.push_back(oneFile);
            }
            //Attiva i due buttons
            chkAllBtn->enable();
            unchkAllBtn->enable();
            //Attiva la lista
            checkList->enable();
            titleCheck->enable();
        }
    }
    return 1;
}


/* Gestore della checklist dei files:
 *  - il controllo  basato sul doppio-click:
 *      - la lista  vuota => messaggio di errore (non dovrebbe mai accadere);
 *      - ha fatto doppio click su un file selezionato => cambia la flag e l'icona.
 *  - quando almeno un file  stato selezionato, disabilita la dirList.
 */
long AddFileDialog::onCmdCheckList(FXObject *sender, FXSelector sel, void *ptr) {
    int item=checkList->getCurrentItem();
    if(item<0) {
        //Non ci sono elementi selezionati - non dovrebbe mai accadere
        FXMessageBox::error(this, MBOX_OK, "A Message from the App","No curr item");
        return 1;
    }
    //Un elemento  stato selezionato
    changeFileStat(item, !filesInFolder[item].add);
    return 1;
}


/* Gestore della richesta cambio cartella dal menu:
 *  - esegue automaticamente la scansione della cartella (vedi nota inizializzazione dirList
 *    al termine del costruttore).
 */
long AddFileDialog::onCmdChangeDir(FXObject *sender, FXSelector sel, void *ptr) {
    FXMenuCommand *menuEntry=(FXMenuCommand*)sender;
    dirList->setDirectory( menuEntry->getText(), true );
    return 1;
}


/* Aggiunge la cartella corrente a quelle preferite dell'utente:
 *  - controlla se  gi presente.
 */
long AddFileDialog::onCmdAddPrefDir(FXObject *sender, FXSelector sel, void *ptr) {
    //Prende la cartella corrente
    FXString currDir=dirList->getDirectory();
    unsigned prefs=options->prefInputPaths.size();
    bool isNew=true;
    for(unsigned i=0; i<prefs; i++) {
        if(currDir==options->prefInputPaths[i]) { isNew=false; break; }
    }
    if(isNew) {
        options->prefInputPaths.push_back( currDir );
        if(prefs==0) delete noItems; //Cancella il 'segnaposto'
        //Crea (lato client) la nuova voce del menu
        FXMenuCommand *temp=new FXMenuCommand(prefMenu, currDir, iconsSmall[ICON_FOLDER_STAR], this, AddFileDialog::ID_CHANGEDIR);
        //Crea (lato server) la nuova voce del menu
        temp->create();
        //Aggiorna (lato server) il menu preferiti
        prefMenu->create();
    }
    return 1;
}




/** CLASSE AddFileDialog: ALTRE FUNZIONI **/

/* Gestisce il cambio di flag del file selezionato:
 *  - item = numero del file da trattare (in riferimento alla lista);
 *  - newStat = il nuovo valore della flag (checked o no);
 *  - se newStat  uguale allo stato attuale, esce senza apportare modifiche.
 */
void AddFileDialog::changeFileStat(int item, bool newStat) {
    bool currStat=filesInFolder[item].add;
    if(currStat!=newStat) {
        filesInFolder[item].add=newStat;
        if(newStat==true) {
            //Aggiorna il contatore dei files selezionati
            selected++;
            //Cambia icona
            checkList->setItemMiniIcon(item, iconsSmall[ICON_CHECKMARK_GREEN]);
            //Non pu pi cambiare cartella
            if(selected==1) {
                titleDir->disable();
                dirList->disable();
                dktDirBtn->disable();
                docDirBtn->disable();
                recentBtn->disable();
                prefBtn->disable();
                prefEditBtn->disable();
            }
        }
        else {
            //Aggiorna il contatore dei files selezionati
            selected--;
            //Cambia icona
            checkList->setItemMiniIcon(item, iconsSmall[ICON_BLANK_GRAY]);
            //Pu nuovamente cambiare cartella
            if(selected==0) {
                titleDir->enable();
                dirList->enable();
                dktDirBtn->enable();
                docDirBtn->enable();
                recentBtn->enable();
                prefBtn->enable();
                prefEditBtn->enable();
            }
        }
    }
}
