#ifndef ADDFILEDIALOG_H_INCLUDED
#define ADDFILEDIALOG_H_INCLUDED

#include "fox-1.6.31-nodep/fx.h"

#include "Icons.h"
#include "WinUtils.h"
#include "Options.h"

#include <vector>


using namespace std;



struct OneFile {
    FXString name;
    bool add;
};

class AddFileDialog : public FXDialogBox {
    //Macro che dichiara alcuni membri della classe
    FXDECLARE(AddFileDialog)

    public:
        //Costruttore, costruisce la finestra (client-side)
        AddFileDialog(FXWindow* owner, FXIcon *_iconsBig[], FXIcon *_iconsSmall[], Options *_opt);
        //Distruttore
        virtual ~AddFileDialog();
        //Visualizza la finestra (server side)
        //Assente, si usa execute
        //Message IDs
        enum {
            ID_DKTDIR=FXDialogBox::ID_LAST, //Usando FXMainWindow::ID_LAST non funzionano ID_CANCELL ecc.
            ID_DOCDIR,
            ID_CHKALL,
            ID_UNCHKALL,
            ID_DIRLIST,
            ID_CHECKLIST,
            ID_ADDFILES,
            ID_CHANGEDIR,
            ID_ADDPREFDIR,
            ID_LAST
        };
        //Callbacks
        long onCmdBrowseBtn(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdSelectBtn(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdDirList(FXObject *sender, FXSelector sel, void *ptr=NULL);
        long onCmdCheckList(FXObject *sender, FXSelector sel, void *ptr=NULL);
        long onCmdChangeDir(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdAddPrefDir(FXObject *sender, FXSelector sel, void *ptr);
        //Altre funzioni di controllo
        void changeFileStat(int item, bool newStat);
        //Funzioni per salvare l'elenco dei file selezionato in MyWindow
        unsigned getNumFiles(void) { return filesInFolder.size(); }
        FXString getFileName(unsigned i) { return i<filesInFolder.size() ? filesInFolder[i].name : "IndexError"; }
        FXString getFilePath(void) { return dirList->getDirectory(); }
        bool getFileFlag(unsigned i) { return filesInFolder[i].add; }

    protected:
        //Costruttore di default della classe derivata (richiesto dalla macro inziale)
        AddFileDialog() { }

    private:
        //Icone
        FXIcon **iconsSmall, **iconsBig;
        //Puntatori agli elementi della finestra
        //Frames
        FXHorizontalFrame *mainFrame;
        FXVerticalFrame *dialogFrame, *leftFrame, *rightFrame;
        FXHorizontalFrame *leftBtnFrame, *rightBtnFrame, *lowerFrame;
        //Albero delle cartelle
        FXLabel *titleDir;
        FXDirList *dirList;
        FXButton *dktDirBtn, *docDirBtn;
        //Elenco dei files nella cartella
        FXLabel *titleCheck;
        FXIconList *checkList;
        FXButton *chkAllBtn, *unchkAllBtn;
        FXMenuButton *recentBtn, *prefBtn, *prefEditBtn;
        FXMenuPane *recentMenu, *prefMenu, *prefEditMenu;
        FXMenuCommand *addPrefDir;
        FXLabel *noItems;
        //Buttons del dialogo
        FXButton *addCheckedBtn, *cancelBtn;
        //Vettore dei files esistenti nella cartella selezionata
        vector<OneFile> filesInFolder;
        unsigned selected;
        //Le opzioni del programma (puntatore a quelle della MyWindow)
        Options *options;
};


#endif // ADDFILEDIALOG_H_INCLUDED
