#include "ConvertDialog.h"


/** CLASSE ConvertDialog: FOX's MACROS **/

/* Macro, message map:
 *  - message type: what appened;
 *  - message id: source;
 *  - message handler: what to do.
 */
FXDEFMAP(ConvertDialog) ConvertDialogMap[]={
   //_________Message_Type_____________________ID__________________________Message_Handler_______________
   //FXMAPFUNC(   SEL_CLOSE,           ConvertDialog::ID_MYBOX,      ConvertDialog::onCmdClose      )
};


/* Macro, message map implementation:
 *  - 1, the name of the class;
 *  - 2, the name of the parent class;
 *  - 3, pointer to message map;
 *  - 4, no. of messages in message map.
 */
FXIMPLEMENT(ConvertDialog, FXDialogBox, ConvertDialogMap, ARRAYNUMBER(ConvertDialogMap))




/** CLASSE ConvertDialog: COSTRUTTORE E DISTRUTTORE **/

/* This function builds the window:
 *  - 1, pointer to the FXWindow owner;
 *  - 2, the window title;
 *  - 5, window decorations;
 *  - 6, initial position, w;
 *  - 7, initial position, h;
 *  - 8, initial size, w;
 *  - 9, initial size, h.
 */
ConvertDialog::ConvertDialog(FXWindow* owner, FXIcon *_iconsBig[], FXIcon *_iconsSmall[]) : FXDialogBox(owner, "ShapeConverter", DECOR_TITLE|DECOR_CLOSE|DECOR_BORDER, 0, 0, 250, 150, 0,0,0,0) {
    //Here we can build the window

    /// Icons
    iconsBig=_iconsBig;
    iconsSmall=_iconsSmall;
    setIcon(iconsBig[ICON_WINDOW]);
    setMiniIcon(iconsSmall[ICON_WINDOW]);

    /// Dialog frame
    dialogFrame=new FXVerticalFrame(this, LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_SUNKEN,0,0,0,0, 5,5, 5,5, 5,5);
        /// Upper frame
        upperFrame=new FXHorizontalFrame(dialogFrame, LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 5,5, 5,5, 5,5);
        new FXLabel(upperFrame, "", iconsBig[ICON_WAIT], 0,0,0,0,0, 10,10, 5,5);
        labelFrame=new FXVerticalFrame(upperFrame, LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 0,0, 0,0, 0,0);
        fileText=new FXLabel(labelFrame, "Please wait...", NULL, LAYOUT_CENTER_X,0,0,0,0, 10,10, 5,5);
        operText=new FXLabel(labelFrame, "", NULL, LAYOUT_CENTER_X,0,0,0,0, 10,10, 5,5);
        new FXSeparator(dialogFrame);//, 0,0,0,0,0,0,5,5);
        /// Lower frame
        lowerFrame=new FXHorizontalFrame(dialogFrame, LAYOUT_FILL_Y|LAYOUT_CENTER_X,0,0,0,0, 5,5, 10,0, 5,0);
        new FXButton(lowerFrame, "Cancel", NULL, this, FXDialogBox::ID_ACCEPT, BUTTON_NORMAL|LAYOUT_CENTER_X,0,0,0,0,10,10,5,5);

    /// End of ConvertDialog
}

/* Distruttore:
 *  - only MenuPanes, Cursors, Fonts, Images, Icons, Bitmaps, and Visuals.
 *  - see 'http://www.fox-toolkit.com/faq.html#DELETINGSTUFF'.
 */
ConvertDialog::~ConvertDialog() {
    //Nothing to do (icons belong to MyWindow class)
}




/** CLASSE ConvertDialog: CALLBACKS functions **/

/* In chiusura:
 *  - fornisce il consenso alla chiusura.
 */
/*long ConvertDialog::onCmdClose(FXObject *sender, FXSelector sel, void *ptr) {
    count++;
    if(count<3) return 1;
    else return 0; // 0 => la finestra pu distruggersi
}*/
