#ifndef CONVERTDIALOG_H_INCLUDED
#define CONVERTDIALOG_H_INCLUDED

#include <vector>

#include "fox-1.6/fx.h"

#include "Icons.h"



class ConvertDialog : public FXDialogBox {
    //Macro che dichiara alcuni membri della classe
    FXDECLARE(ConvertDialog)

    public:
        //Costruttore, costruisce la finestra (client-side)
        ConvertDialog(FXWindow* owner, FXIcon *_iconsBig[], FXIcon *_iconsSmall[]);
        //Distruttore
        virtual ~ConvertDialog();
        //Visualizza la finestra (server side)
        //Assente, si usa execute
        //Message IDs: none
        enum {
            ID_MYBOX=FXDialogBox::ID_LAST, //Usando FXMainWindow::ID_LAST non funzionano ID_CANCELL ecc.
            ID_LAST
        };
        //Callbacks
        //long onCmdClose(FXObject *sender, FXSelector sel, void *ptr);
        //Funzioni
        void setFileText(FXString txt) { fileText->setText(txt); }
        void setOperText(FXString txt) { operText->setText(txt); }

    protected:
        //Costruttore di default della classe derivata (richiesto dalla macro inziale)
        ConvertDialog() { }

    private:
        //Icone
        FXIcon **iconsSmall, **iconsBig;
        //Puntatori agli elementi della finestra
        FXVerticalFrame *dialogFrame, *labelFrame;
        FXHorizontalFrame *upperFrame, *lowerFrame;
        FXLabel *fileText, *operText;
};


#endif // CONVERTDIALOG_H_INCLUDED
