#include "MyWindow.h"


/** CLASSE MyWindow: FOX's MACROS **/

/* Macro, message map:
 *  - message type: what appened;
 *  - message id: source;
 *  - message handler: what to do.
 */
FXDEFMAP(MyWindow) MyWindowMap[]={
   //_________Message_Type_____________________ID__________________________Message_Handler____________
   FXMAPFUNC(   SEL_COMMAND,           MyWindow::ID_ABOUT,        MyWindow::onCmdAbout              ),
   FXMAPFUNC(   SEL_COMMAND,           MyWindow::ID_ADDFILE,      MyWindow::onCmdAddFile            ),
   FXMAPFUNC(   SEL_COMMAND,           MyWindow::ID_DELFILE,      MyWindow::onCmdDelFile            ),
   FXMAPFUNC(   SEL_COMMAND,           MyWindow::ID_DELALLFILES,  MyWindow::onCmdDelFile            ),
   FXMAPFUNC(   SEL_UPDATE,            MyWindow::ID_FILELIST,     MyWindow::onUpdFileList           ),
   FXMAPFUNC(   SEL_COMMAND,           MyWindow::ID_CONVERT,      MyWindow::onCmdConvert            ),
   FXMAPFUNC(   SEL_COMMAND,           MyWindow::ID_OPTIONS,      MyWindow::onCmdOptions            ),
   FXMAPFUNC(   SEL_CLOSE,             MyWindow::ID_MYWINDOW,     MyWindow::onCmdClose              )
};


/* Macro, message map implementation:
 *  - 1, the name of the class;
 *  - 2, the name of the parent class;
 *  - 3, pointer to message map;
 *  - 4, no. of messages in message map.
 */
FXIMPLEMENT(MyWindow, FXMainWindow, MyWindowMap, ARRAYNUMBER(MyWindowMap))




/** CLASSE MyWindow: COSTRUTTORE E DISTRUTTORE **/

/* This function builds the window:
 *  - 1, pointer to the FXApp;
 *  - 2, the window title;
 *  - 3, window icon, big;
 *  - 4, window icon, small;
 *  - 5, window decorations;
 *  - 6, initial position, w;
 *  - 7, initial position, h;
 *  - 8, initial size, w;
 *  - 9, initial size, h.
 */
MyWindow::MyWindow(FXApp *a) : FXMainWindow(a, "ShapeConverter R4.1", NULL, NULL, DECOR_TITLE|DECOR_MINIMIZE|DECOR_CLOSE|DECOR_BORDER|DECOR_MENU, 0, 0, 500, 400) {
    //Here we can build the window

    /// Intercetta il comando SEL_CLOSE alla chiusura della finestra principale
    setTarget(this);
    setSelector(ID_MYWINDOW);

    /// Inizializzazione impostazioni
    //Impostazioni di default
    options.anims=1;
    options.lods=2;
    options.log=1;
    options.mat=1;
    options.out=1;
    options.outPath="C:";
    options.ffed=2;
    options.ffedPath="";
    options.temp=2;
    //options.tempPath=FXSystem::getTempDirectory();//win::getDirPath(options.tempPath, win::DIR_TEMP);
    options.tempPath=FXPath::expand( FXSystem::getTempDirectory() );
    //Impostazioni attuali (lette da file, se esiste)
    cfg::loadConfig("config.txt", &options);

    /// Load Icons
    //Inizializzazione
    for(unsigned i=0; i<ICON_NUM; i++) {
        iconsSmall[i]=NULL;
        iconsBig[i]=NULL;
    }
    //SMALL ICONS
    iconsSmall[ICON_WINDOW]             =new FXGIFIcon(getApp(), lego_icon_16_gif);
    iconsSmall[ICON_BLANK_GRAY]         =new FXGIFIcon(getApp(), icon_blank_smokecons_gif);
    iconsSmall[ICON_CHECKMARK_GREEN]    =new FXGIFIcon(getApp(), icon_checkmark_greencons_gif);
    iconsSmall[ICON_CANCEL_RED]         =new FXGIFIcon(getApp(), icon_cancel_redcons_gif);
    iconsSmall[ICON_EXLAMATION_GRAY]    =new FXGIFIcon(getApp(), icon_exlamation_smokecons_gif);
    iconsSmall[ICON_PAGE_RED]           =new FXGIFIcon(getApp(), icon_page_red_fam_gif);
    iconsSmall[ICON_PAGE_BLUE]          =new FXGIFIcon(getApp(), icon_page_blue_fam_gif);
    iconsSmall[ICON_PAGE_ERROR]         =new FXGIFIcon(getApp(), icon_page_error_fam_gif);
    iconsSmall[ICON_PAGE_OK]            =new FXGIFIcon(getApp(), icon_page_ok_fam_gif);
    iconsSmall[ICON_DOOR_EXIT]          =new FXGIFIcon(getApp(), icon_door_exit_fam_gif);
    iconsSmall[ICON_FOLDER_STAR]        =new FXGIFIcon(getApp(), icon_folder_star_fam_gif);
    iconsSmall[ICON_FOLDER_ADD]         =new FXGIFIcon(getApp(), icon_folder_add_fam_gif);
    iconsSmall[ICON_FOLDER_CLOCK]       =new FXGIFIcon(getApp(), icon_folder_clock_fam_gif);
    iconsSmall[ICON_FOLDER_GO]          =new FXGIFIcon(getApp(), icon_folder_go_fam_gif);
    iconsSmall[ICON_INFORMATION]        =new FXGIFIcon(getApp(), icon_information_fam_gif);
    iconsSmall[ICON_OPTIONS]            =new FXGIFIcon(getApp(), icon_options_edit_fam_gif);
    iconsSmall[ICON_BRICK_GO]           =new FXGIFIcon(getApp(), icon_brick_go_fam_gif);
    //BIG ICONS
    iconsBig[ICON_WINDOW]               =new FXGIFIcon(getApp(), lego_icon_32_gif);
    iconsBig[ICON_ABOUT]                =new FXGIFIcon(getApp(), lego_icon_about_gif);
    iconsBig[ICON_DESKTOP]              =new FXGIFIcon(getApp(), icon_desktop_big_nuvola_gif);
    iconsBig[ICON_DOCUMENTS]            =new FXGIFIcon(getApp(), icon_folder_yellow_big_nuvola_gif);
    iconsBig[ICON_RECENTS]              =new FXGIFIcon(getApp(), icon_clock_big_nuvola_gif);
    iconsBig[ICON_PREFS]                =new FXGIFIcon(getApp(), icon_pref_big_nuvola_gif);
    iconsBig[ICON_OPT_FOLDER]           =new FXGIFIcon(getApp(), icon_opt_folder_big_moore_gif);
    iconsBig[ICON_OPT_APP]              =new FXGIFIcon(getApp(), icon_opt_app_big_moore_gif);
    iconsBig[ICON_OPT_PREF]             =new FXGIFIcon(getApp(), icon_opt_pref_big_moore_gif);
    //CREA LE ICONE (server side)
    for(unsigned i=0; i<ICON_NUM; i++) {
        if(iconsSmall[i]!=NULL) iconsSmall[i]->create();
        if(iconsBig[i]!=NULL) iconsBig[i]->create();
    }
    //iconsBig[ICON_ABOUT]->setOptions(IMAGE_OPAQUE);//blend(FXRGB(0,0,0));

    /// Set window icons
    setIcon(iconsBig[ICON_WINDOW]);
    setMiniIcon(iconsSmall[ICON_WINDOW]);

    /// Tooltip
    new FXToolTip(getApp()); //, TOOLTIP_NORMAL);

    /// Status bar
    statusBar=new FXStatusBar(this, LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);

    /// Menubar
    menuBar=new FXMenuBar(this, LAYOUT_SIDE_TOP|LAYOUT_FILL_X); //|FRAME_RAISED);
        /// File Menu
        fileMenu=new FXMenuPane(this);
        new FXMenuCommand(fileMenu, "&Add Files...\tCtrl-A\tAdd files to the list", iconsSmall[ICON_FOLDER_GO], this, MyWindow::ID_ADDFILE);
        convCmd=new FXMenuCommand(fileMenu, "&Convert all files\tCtrl-C\tConvert all the files", iconsSmall[ICON_BRICK_GO], this, MyWindow::ID_CONVERT);
        convCmd->disable();
        new FXMenuSeparator(fileMenu);
        new FXMenuCommand(fileMenu, "&Exits\tCtrl-E\tQuit the application", iconsSmall[ICON_DOOR_EXIT], this, FXMainWindow::ID_CLOSE);
        new FXMenuTitle(menuBar, "&File", NULL, fileMenu);
        /// Settings Menu
        settMenu=new FXMenuPane(this);
        new FXMenuCommand(settMenu," &Options...\tCtrl-O\tEdit program options", iconsSmall[ICON_OPTIONS], this, MyWindow::ID_OPTIONS);
        new FXMenuTitle(menuBar, "&Settings", NULL, settMenu);
        /// Help Menu
        helpMenu=new FXMenuPane(this);
        new FXMenuCommand(helpMenu," &About...\tCtrl-A\tAbout ShapeConverter", iconsSmall[ICON_INFORMATION], this, MyWindow::ID_ABOUT);
        new FXMenuTitle(menuBar, "&Help", NULL, helpMenu);

    /// Main frame
    mainFrame=new FXVerticalFrame(this, LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_SUNKEN,0,0,0,0, 5,5, 5,5, 5,5);
        /// File list
        fileList=new FXIconList(mainFrame, this, ID_FILELIST, LIST_SINGLESELECT|LAYOUT_FILL_X|LAYOUT_FILL_Y);//|LAYOUT_FIX_HEIGHT,0,0,0,200);
        fileList->appendHeader("File", NULL, 140); //Null  l'icona
        fileList->appendHeader("Path", NULL, 140); //Null  l'icona
        fileList->appendHeader("Status", NULL, 190); //Null  l'icona
        /// Buttons frame
        btnFrame=new FXHorizontalFrame(mainFrame, LAYOUT_FILL_X|FRAME_RAISED,0,0,0,0, 5,5, 5,5, 5,5);
            /// Buttons
            addBtn=new FXButton(btnFrame, "Add to list...", NULL, this, MyWindow::ID_ADDFILE, BUTTON_NORMAL|BUTTON_INITIAL|LAYOUT_LEFT,0,0,0,0,10,10,5,5);
            delBtn=new FXButton(btnFrame, "Delete selected", NULL, this, MyWindow::ID_DELFILE, BUTTON_NORMAL|LAYOUT_LEFT,0,0,0,0,10,10,5,5);
            clrBtn=new FXButton(btnFrame, "Clear list", NULL, this, MyWindow::ID_DELALLFILES, BUTTON_NORMAL|LAYOUT_LEFT,0,0,0,0,10,10,5,5);
            conBtn=new FXButton(btnFrame, "Convert all!", NULL, this, MyWindow::ID_CONVERT, BUTTON_NORMAL|LAYOUT_RIGHT,0,0,0,0,10,10,5,5);
            delBtn->disable();
            clrBtn->disable();
            conBtn->disable();
        /*/// Progress bar frame
        progrMatrix=new FXMatrix(mainFrame, 2, MATRIX_BY_COLUMNS|LAYOUT_FILL_X|FRAME_RAISED,0,0,0,0, 5,5, 5,5, 5,5);
            /// DataTargets
            fileProg=0;
            allProg=0;
            fileBarDT.connect(fileProg);
            allBarDT.connect(allProg);
            /// Status bar
            new FXLabel(progrMatrix, "All files:", NULL, LAYOUT_CENTER_Y|LAYOUT_RIGHT);
            allProgrBar=new FXProgressBar(progrMatrix, &allBarDT, FXDataTarget::ID_VALUE, FRAME_THICK|PROGRESSBAR_PERCENTAGE|LAYOUT_FILL_COLUMN|LAYOUT_FILL_X);
            new FXLabel(progrMatrix, "Current file:", NULL, LAYOUT_CENTER_Y|LAYOUT_RIGHT);
            fileProgrBar=new FXProgressBar(progrMatrix, &fileBarDT, FXDataTarget::ID_VALUE, FRAME_THICK|PROGRESSBAR_PERCENTAGE|LAYOUT_FILL_COLUMN|LAYOUT_FILL_X);
*/
    /// End of MyWindow
}

/* Distruttore:
 *  - only MenuPanes, Cursors, Fonts, Images, Icons, Bitmaps, and Visuals.
 *  - see 'http://www.fox-toolkit.com/faq.html#DELETINGSTUFF'.
 */
MyWindow::~MyWindow() {
    delete fileMenu;
    delete settMenu;
    delete helpMenu;
    //delete iconSmall;
    //delete iconBig;
    for(unsigned i=0; i<ICON_NUM; i++) {
        if(iconsSmall[i]!=NULL) delete iconsSmall[i];
        if(iconsBig[i]!=NULL) delete iconsBig[i];
    }
}




/** CLASSE MyWindow: CREATE function **/

/* This function tells to the server we are ready:
 *  - displays the window on screen.
 */
void MyWindow::create(){
    //Create the windows
    FXMainWindow::create();
    //Make the main windows appear
    show(PLACEMENT_SCREEN); //This could be changed (see tutorial 1)
}




/** CLASSE MyWindow: CALLBACKS functions **/

/* Menu help/about:
 *  - informazioni sul programma.
 */
long MyWindow::onCmdAbout(FXObject *sender, FXSelector sel, void *ptr) {
    //FXMessageBox about(this,"About Shape Converter","Image Viewer demonstrates the FOX ImageView widget.\n\nUsing the FOX C++ GUI Library (http://www.fox-toolkit.org)\n\nCopyright (C) 2000,2004 Jeroen van der Zijp (jeroen@fox-toolkit.org)",NULL,MBOX_OK|DECOR_TITLE|DECOR_BORDER);
    //about.execute();
    AboutDialog dlg(this, iconsBig, iconsSmall);
    dlg.execute(PLACEMENT_OWNER);
    return 1;
}


/* Aggiunge uno o pi files alla lista:
 *  - crea ed esegue una finestra di dialogo 'AddFileDialog';
 *  - se questa restituisce 1 (coi l'utente preme OK), la funzione chiede al dialogo di passare
 *    le informazioni sui file da aggiungere;
 *  - i files vengono controllati e, se sono del tipo richesto vengono aggiunti alla lista; altrimenti
 *    viene mostrata una messagebox di errore.
 */
long MyWindow::onCmdAddFile(FXObject *sender, FXSelector sel, void *ptr) {
    //Crea la dialogBox
    AddFileDialog dlg(this, iconsBig, iconsSmall, &options);
    //Esegue la dialogBox
    if(dlg.execute(PLACEMENT_OWNER)!=1) return 1;
    //E' uscito con OK dalla dialogBox
    //Aggiunge i files all'elenco
    FXString path("\t"), oneRow;
    path.append(dlg.getFilePath());
    path.append("\tReady");
    //Numero di files gi in lista
    unsigned esistenti=fileList->getNumRows();
    //Numero di files presenti nella lista del dialogo
    unsigned num=dlg.getNumFiles();
    for(unsigned i=0; i<num; i++) {
        //Ha selezionato uno o pi files
        //Controlla se  da aggiungere
        if(dlg.getFileFlag(i)==false) continue;
        //Completa la stringa: <nomefile>'\t'<percorso>'\t'<"Ready">
        oneRow=path;
        oneRow.prepend(dlg.getFileName(i));
        //Controlla se  gi in lista (todo)
        bool exist=false;
        for(unsigned j=0; j<esistenti; j++) {
            if(fileList->getItemText(j)==oneRow) {
                exist=true;
                FXMessageBox::information(this, MBOX_OK, "ShapeConverter","This file:\n%s\\%s\n is in the list yet!",dlg.getFilePath().text(),dlg.getFileName(i).text());
                break;
            }
        }
        //Prosegue solo se non  presente in lista
        if(exist==false) {
            //Controllo sul formato
            int formato=shape::checkFormat( dlg.getFilePath()+"\\"+dlg.getFileName(i) );
            if(formato==0) {
                //E' binario
                if(options.ffed==1) {
                    //Lo aggiunge solo se c' ffeditc
                    fileList->appendItem(oneRow, NULL, iconsSmall[ICON_PAGE_RED]);
                }
            }
            else if(formato==1) {
                //E' utf-16
                fileList->appendItem(oneRow, NULL, iconsSmall[ICON_PAGE_BLUE]);
            }
            //Altrimenti non lo aggiunge
            else FXMessageBox::error(this, MBOX_OK, "ShapeConverter","Unknown file format:\n%s\\%s",dlg.getFilePath().text(),dlg.getFileName(i).text());
        }
    }
    //Aggiorna l'elenco delle cartelle recenti
    FXString currDir=dlg.getFilePath();
    unsigned recents=options.recentInputPaths.size();
    bool isNew=true;
    for(unsigned i=0; i<recents; i++) {
        if(currDir==options.recentInputPaths[i]) { isNew=false; break; }
    }
    if(isNew) {
        if(recents>4) options.recentInputPaths.pop_back();
        options.recentInputPaths.insert( options.recentInputPaths.begin(), currDir );
    }
    return 1;
}


/* Cancella uno o pi files dalla lista:
 *  - no comment.
 */
long MyWindow::onCmdDelFile(FXObject *sender, FXSelector sel, void *ptr) {
    int item=fileList->getCurrentItem();
    switch( FXSELID(sel) ) {
        case MyWindow::ID_DELFILE:
            if(item>=0) {
                //Cancella dall'elenco il file selezionato
                fileList->removeItem(item);
            }
            break;
        case MyWindow::ID_DELALLFILES:
            fileList->clearItems();
            break;
    }
    return 1;
}


/* Gestisce l'attivazione dei pulsanti della lista dei files e la voce del menu file:
 *  - almeno un file presente => attiva conBtn, clrBtn, convCmd;
 *  - un file selezionato => attiva delBtn.
 */
long MyWindow::onUpdFileList(FXObject *sender, FXSelector sel, void *ptr) {
    if(fileList->getNumRows()>0) {
        clrBtn->enable();
        conBtn->enable();
        convCmd->enable();
        if( fileList->isItemSelected( fileList->getCurrentItem() ) ) delBtn->enable();
        else delBtn->disable();
    }
    else {
        clrBtn->disable();
        conBtn->disable();
        delBtn->disable();
        convCmd->disable();
    }
    return 1;
}


/* Esegue la conversione dei files:
 *  - todo.
 */
long MyWindow::onCmdConvert(FXObject *sender, FXSelector sel, void *ptr) {
    /*//Crea il dialogo
    ConvertDialog *dlg=new ConvertDialog(this, iconsBig, iconsSmall);
    //Lo crea lato server
    dlg->create();
    //Chiede di mostrarlo
    dlg->show(PLACEMENT_OWNER);
    //Esegue il dialogo (permette di mostrare il contenuto)
    getApp()->runModalWhileEvents(dlg);*/
    //ProgressDialog
    ProgressDialog dlg(this, "ShapeConverter");
    FXString label, temp;
    dlg.create();
    dlg.show(PLACEMENT_OWNER);
    this->getApp()->beginWaitCursor();
    this->getApp()->runModalWhileEvents(&dlg);
    //Una riga della tabella
    FXString oneRow;
    //Risultato della conversione
    int result=0;
    //Numero di righe
    unsigned n=fileList->getNumRows();
    dlg.setTotal(n);
    dlg.setFileTot(n);
    //Per ogni riga...
    for(unsigned i=0; i<n; i++) {
        //Prende il testo della riga
        oneRow=fileList->getItemText(i);
        //Aggiorna label
        label="File '"+oneRow.section('\t',0)+temp.format("' (%d of %d)", i+1, n);
        dlg.setTopLabel(label);
        //Conversione dell'i-esimo file
        if(fileList->getItemMiniIcon(i)==iconsSmall[ICON_PAGE_RED]) {
            //E' in formato compresso - lo converte
            dlg.setMidLabel("Converting from binary to unicode...");
            //Stringa da passare alla console dei comandi
            FXString cmd;
            cmd = "( " + FXPath::drive(options.ffedPath) + " & cd " + FXPath::directory(options.ffedPath) +
                  " & ffeditc_unicode.exe \"" + oneRow.section('\t',1) + '\\' + oneRow.section('\t',0) + "\" /o:" +
                  options.tempPath + "\\ShapeConverterTemp.s )";
            //Lancia il comando (o la sequenza di comandi alla console): restituisce 1 se fallisce, 0 altrimenti
            int uncpr=std::system(cmd.text());
            if(uncpr==0) {
                //Il file  stato decompresso e si trova nella cartella temporanea
                //Lo converte
                result=conv::convert( oneRow.section('\t',0), oneRow.section('\t',1), true, options, dlg );
                //Cancella il file temporaneo
                win::deleteFile( options.tempPath+"\\ShapeConverterTemp.s" );
            }
            else {
                //Il file non  stato decompresso
                result=2;
            }
        }
        else if(fileList->getItemMiniIcon(i)==iconsSmall[ICON_PAGE_BLUE]) {
            //E' gi in formato unicode - lo converte
            result=conv::convert( oneRow.section('\t',0), oneRow.section('\t',1), false, options, dlg );
        }
        else {
            //Gi convertito (con successo o no)
            continue;
        }
        //Aggiorna la stringa da inserire nella tabella
        if(result==0) {
            //Convertito con successo
            oneRow=oneRow.section('\t',0)+'\t'+oneRow.section('\t',1)+"\tFile converted!";
            dlg.incrFileCorr();
            //fileList->setItemMiniIcon(i, iconsSmall[ICON_PAGE_OK]);
            //fileList->setItemText(i, oneRow);
        }
        else if(result==1) {
            //Conversione fallita
            oneRow=oneRow.section('\t',0)+'\t'+oneRow.section('\t',1)+"\tError! Conversion failed!";
            dlg.incrFileErr();
            //fileList->setItemMiniIcon(i, iconsSmall[ICON_PAGE_ERROR]);
            //fileList->setItemText(i, oneRow);
        }
        else if(result==2) {
            //Conversione fallita
            oneRow=oneRow.section('\t',0)+'\t'+oneRow.section('\t',1)+"\tError! Can't convert to unicode!";
            dlg.incrFileErr();
        }
        else if(result==3) {
            //Conversione fallita
            oneRow=oneRow.section('\t',0)+'\t'+oneRow.section('\t',1)+"\tCancelled by user.";
            dlg.incrFileErr();
        }
        //Aggiorna la riga della tabella
        fileList->setItemMiniIcon( i, result==0 ? iconsSmall[ICON_PAGE_OK] : iconsSmall[ICON_PAGE_ERROR] );
        fileList->setItemText(i, oneRow);
        //FXMessageBox::information(this, MBOX_OK, "ShapeConverter","Error: %d/%d/%d/%d/%d/%d", err.a, err.b, err.c, err.d, err.e, err.f);
        //Controllo la coda dei messaggi prima di riprendere il ciclo
        if(!dlg.check()) break;
        /*//Controlla la coda dei messaggi del dialogo (interrompe il ciclo se clicca su cancel)
        dlg.setProgress(i);
        this->getApp()->runModalWhileEvents(&dlg);
        if(dlg.isCancelled()) {
            dlg.hide();
            // other cleanup
            this->getApp()->endWaitCursor();
            //FXMessageBox::information(this, MBOX_OK, this->getTitle().text(), "i=%d", i);
            return 1;
        }*/
    }
    //Mostra i risultati
    getApp()->endWaitCursor();
    dlg.showResults();
    dlg.hide();
    //Fine
    return 1;
}


/* Opzioni di conversione:
 *  - no comment.
 */
long MyWindow::onCmdOptions(FXObject *sender, FXSelector sel, void *ptr) {
    //Crea la dialogBox
    OptionsDialog dlg(this, iconsBig, iconsSmall, &options);
    //Esegue la dialogBox
    if(dlg.execute(PLACEMENT_OWNER)!=1) return 1;
    //E' uscito con OK dalla dialogBox
    //Aggiorna le opzioni
    dlg.getOptions(options);
    return 1;
}


/* In chiusura:
 *  - scrive il file delle configurazioni.
 */
long MyWindow::onCmdClose(FXObject *sender, FXSelector sel, void *ptr) {
    cfg::saveConfig("config.txt", &options);
    return 0; // 0 => la finestra pu distruggersi
}
