#ifndef MYWINDOW_H_INCLUDED
#define MYWINDOW_H_INCLUDED

#include "fox-1.6.31-nodep/fx.h"

#include <vector>

#include "Icons.h"
#include "AddFileDialog.h"
#include "OptionsDialog.h"
#include "AboutDialog.h"
#include "ProgressDialog.h"
#include "Config.h"
#include "ShapeFormat.h"
#include "Convertitore.h"


class MyWindow : public FXMainWindow {
    //Macro che dichiara alcuni membri della classe
    FXDECLARE(MyWindow)

    public:
        //Costruttore, costruisce la finestra (client-side)
        MyWindow(FXApp *a);
        //Distruttore
        virtual ~MyWindow();
        //Visualizza la finestra (server side)
        virtual void create();
        //Message IDs
        enum {
            ID_MYWINDOW=FXMainWindow::ID_LAST,
            ID_ABOUT,
            ID_FILELIST,
            ID_TEST,
            ID_ADDFILE,
            ID_DELFILE,
            ID_DELALLFILES,
            ID_CONVERT,
            ID_OPTIONS,
            ID_LAST
        };
        //Callbacks
        long onCmdAbout(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdAddFile(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdDelFile(FXObject *sender, FXSelector sel, void *ptr);
        long onUpdFileList(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdConvert(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdOptions(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdClose(FXObject *sender, FXSelector sel, void *ptr);
        //Icon functions
        //FXIcon *getIconSmall(void) { return iconSmall; }
        //FXIcon *getIconBig(void) { return iconBig; }

    protected:
        //Costruttore di default della classe derivata (richiesto dalla macro inziale)
        MyWindow() {}
        //Icone
        //FXGIFIcon *iconSmall, *iconBig;
        FXIcon *iconsSmall[ICON_NUM], *iconsBig[ICON_NUM];

    private:
        //Puntatori agli elementi della finestra
        //Frames
        FXVerticalFrame *mainFrame;
        FXHorizontalFrame *btnFrame;
        FXMatrix *progrMatrix, *currFileMatrix;
        //Barra di stato
        FXStatusBar *statusBar;
        //Menu
        FXMenuBar *menuBar;
        FXMenuPane *fileMenu, *settMenu, *helpMenu;
        FXMenuCommand *convCmd;
        //Lista files
        FXIconList *fileList;
        FXButton *addBtn, *delBtn, *clrBtn, *conBtn;
        /*//Progress
        FXProgressBar *fileProgrBar, *allProgrBar;
        //Datatargets per il controllo delle barre
        FXDataTarget fileBarDT, allBarDT;
        int fileProg, allProg;*/
        //Le impostazioni del programma
        Options options;
};


#endif // MYWINDOW_H_INCLUDED
