#ifndef OPTIONSDIALOG_H_INCLUDED
#define OPTIONSDIALOG_H_INCLUDED

#include "fox-1.6.31-nodep/fx.h"

#include "Icons.h"
#include "Options.h"
#include "WinUtils.h"



using namespace std;



class OptionsDialog : public FXDialogBox {
    //Macro che dichiara alcuni membri della classe
    FXDECLARE(OptionsDialog)

    public:
        //Costruttore, costruisce la finestra (client-side)
        OptionsDialog(FXWindow* owner, FXIcon *_iconsBig[], FXIcon *_iconsSmall[], Options *_opt);
        //Distruttore
        virtual ~OptionsDialog();
        //Visualizza la finestra (server side)
        //Assente, si usa execute
        //Message IDs
        enum {
            ID_OUTCB=FXDialogBox::ID_LAST, //Usando FXMainWindow::ID_LAST non funzionano ID_CANCELL ecc.
            ID_OUTBROW,
            ID_OUTSEE,
            ID_FFEDCB,
            ID_FFEDBROW,
            ID_FFEDSEE,
            ID_TEMPCB,
            ID_TEMPBROW,
            ID_TEMPSEE,
            ID_PREFLIST,
            ID_PREFDEL,
            ID_PREFCLR,
            ID_LAST
        };
        //Callbacks
        long onCmdOutCheckBtn(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdOutBrowse(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdFfedCheckBtn(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdFfedBrowse(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdSeeBtn(FXObject *sender, FXSelector sel, void *ptr);
        long onUpdPrefList(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdDelPref(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdTempCheckBtn(FXObject *sender, FXSelector sel, void *ptr);
        long onCmdTempBrowse(FXObject *sender, FXSelector sel, void *ptr);
        //Aggiorna le opzioni contenute in MyWindow, al termine del dialogo
        void getOptions(Options &options);

    protected:
        //Costruttore di default della classe derivata (richiesto dalla macro inziale)
        OptionsDialog() { }

    private:
        //Icone
        FXIcon **iconsSmall, **iconsBig;
        //Puntatori agli elementi della finestra
        //Switcher e frames
        FXVerticalFrame *dialogFrame, *btnFrame;
        FXHorizontalFrame *mainFrame, *lowerFrame;
        FXSwitcher *switcher;
        FXVerticalFrame *progOpt, *prefOpt;
        FXMatrix *convOpt;
        //Swicher buttons
        FXButton *switchBtn[3];
        //Options 1: program options
        FXGroupBox *outBox, *ffedBox, *tempBox;
        FXHorizontalFrame *outBtnFrame, *ffedBtnFrame, *tempBtnFrame;
        FXButton *outChooseBtn, *outSeeBtn, *ffedChooseBtn, *ffedSeeBtn, *tempChooseBtn, *tempSeeBtn;
        FXCheckButton *outCheckBtn,  *ffedCheckBtn, *tempCheckBtn;
        //Options 2: conversion options
        FXGroupBox *animsBox, *lodsBox, *logBox, *matBox;
        //Options 3: cartelle preferite
        FXIconList *prefList;
        FXButton *prefDelBtn, *prefClrBtn;
        //Buttons del dialogo
        FXButton *saveBtn, *cancelBtn;
        //DataTargets per le opzioni
        FXDataTarget anims;
        FXDataTarget lods;
        FXDataTarget log;
        FXDataTarget mat;
        FXuchar out, ffed, temp;
        FXString outPath, ffedPath, tempPath;
        Options *options;
        //Dialoghi per scelta cartelle
        //FXDirDialog outDlg, ffedDlg;
};


#endif // OPTIONSDIALOG_H_INCLUDED
