#ifndef PROGRESSDIALOG_H_INCLUDED
#define PROGRESSDIALOG_H_INCLUDED


#include "fox-1.6.31-nodep/fx.h"
#include <cmath>



class ProgressDialog : public FXDialogBox {
    //Macro che dichiara alcuni membri della classe
    FXDECLARE(ProgressDialog)

    public:
        //Costruttore, costruisce la finestra (client-side)
        ProgressDialog(FXWindow* owner, FXString title);
        //Distruttore
        virtual ~ProgressDialog();
        //Visualizza la finestra (server side)
        //Assente, si usa execute
        //Message IDs: none
        enum {
            ID_MYBOX=FXDialogBox::ID_LAST, //Usando FXMainWindow::ID_LAST non funzionano ID_CANCELL ecc.
            ID_CANCEL,
            ID_LAST
        };
        //Callbacks
        long onCmdCancel(FXObject *sender, FXSelector sel, void *ptr);
        //Stato di uscita
        bool isCancelled(void) { return cancelled; }
        //Cambio stringhe finestra di dialogo
        void setTopLabel(FXString label) { topLabel->setText(label); }
        void setMidLabel(FXString label) { midLabel->setText(label); }
        void setBotLabel(FXString label) { botLabel->setText(label); }
        //Gestione progress bar
        void setTotal(unsigned value) { progressBar->setTotal(value); }
        unsigned getTotal(void) {return progressBar->getTotal(); }
        void setProgress(unsigned value) { progressBar->setProgress(value); }
        unsigned getProgress(void) { return progressBar->getProgress(); }
        void increment(unsigned value) { progressBar->increment(value); }
        //NEW
        void startOperation(float _step, char *label=NULL, bool restart=false);
        void incrementStep(void);
        void incrementStep(unsigned n);
        //Controlla coda dei messaggi (click su stop durante la conversione)
        bool check(void);
        //Contatori per stringa n. file convertiti
        void setFileTot(unsigned num) { tot=num; botLabel->setText(temp.format(counterStr.text(),corr,err,tot)); }
        void incrFileCorr(void) { corr++; botLabel->setText(temp.format(counterStr.text(),corr,err,tot)); }
        void incrFileErr(void) { err++; botLabel->setText(temp.format(counterStr.text(),corr,err,tot)); }
        void showResults(void);

    protected:
        //Costruttore di default della classe derivata (richiesto dalla macro inziale)
        ProgressDialog() { }

    private:
        //Puntatori agli elementi della finestra
        FXVerticalFrame *dialogFrame;
        FXLabel *topLabel, *midLabel, *botLabel;
        FXButton *cancelBtn;
        FXProgressBar *progressBar;
        //Stato
        bool cancelled;
        //Conto files
        unsigned tot, corr, err;
        FXString temp, counterStr;
        //Controllo barra
        float counter;
        float step;
};


#endif // PROGRESSDIALOG_H_INCLUDED
