#include "ShapeFormat.h"

/* Controlla il formato del file shape. Restituisce:
 *  - 1 se  unicode utf-16 LE;
 *  - 0 se  binario;
 *  - -1 se non  un file shape.
 */
int shape::checkFormat(FXString fullPath) {
    //Apre il file
    std::ifstream shape(fullPath.text());
    if(!shape.is_open()) {
        //Impossibile aprire il file
        return -1;
    }
    //Controlla il "BOM" corrispondente alla codifica utf-16 LE
    char bom[]={ 0xFF, 0xFE }, buff[2];
    shape.read(buff, 2);
    if(bom[0]!=buff[0] || bom[1]!=buff[1]) {
        //Non  unicode
        //Riavvolge il file
        shape.seekg(std::ios::beg);
        //header="SIMISA@"
        char headerBIN[]={0x53, 0x49, 0x4D, 0x49, 0x53, 0x41, 0x40}; //totale 7 bytes
        char ch;
        for(unsigned i=0; i<7; i++) {
            shape.get(ch);
            if(ch!=headerBIN[i]) return -1; //Non  nemmeno binario
        }
        //Se arriva qui il formato  corretto ed  binario
        return 0;
    }
    else {
        //E' unicode utf-16 LE
        //header="S I M I S A @ @ @ @ @ @ @ @ @ @ J I N X 0 s 1 t _ _ _ _ _ _ "
        char headerUTF[]={
            0x53, 0x00, 0x49, 0x00, 0x4D, 0x00, 0x49, 0x00, 0x53, 0x00,
            0x41, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00,
            0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00,
            0x40, 0x00, 0x4A, 0x00, 0x49, 0x00, 0x4E, 0x00, 0x58, 0x00,
            0x30, 0x00, 0x73, 0x00, 0x31, 0x00, 0x74, 0x00, 0x5F, 0x00,
            0x5F, 0x00, 0x5F, 0x00, 0x5F, 0x00, 0x5F, 0x00//, 0x5F, 0x00 eliminati dalla vers. R4
        }; //totale 58 bytes
        //Controlla l'header
        char ch;
        for(unsigned i=0; i<58; i++) {
            shape.get(ch);
            if(ch!=headerUTF[i]) return -1;
        }
        //Se arriva qui il formato  corretto ed  utf-16LE
        return 1;
    }
    //Se arriva qui ' stato un errore
    return -1;
}
