#ifndef CHARUTILS_H_INCLUDED
#define CHARUTILS_H_INCLUDED

#include <string>

#include "Tipi.h"
#include "Errore.h"


using namespace std;



/** FUNZIONI DI CONTROLLO DEI CARATTERI **/

bool isStrTerm(char ch);
bool isNum(char ch);
bool isDot(char ch);
bool isExp(char ch);
bool isSign(char ch);
bool isForm(char ch);



/** FUNZIONI DI CONVERSIONE STR=>NUM **/

template <class tipo> void string2int(string numero, char segno, tipo *num);
void string2float(string mantInt, string mantDec, string exp, char segnoMant, char segnoExp, f32 *num);



/** FUNZIONI PER CONTROLLO DIMENSIONE NUMERI **/

void checkIntLenght(string num, s8 sign);



/** FUNZIONI DI CONVERSIONE STR=>NUM: IMPLEMENTAZIONE TEMPLATE **/
//Per evitare errore 'undefined reference' e poter includere comunque il file h viene implementata qui

/* Trasforma la stringa in ingresso in un intero signed 32bit:
 *  - salva il segno;
 *  - controllo lunghezza numero: lancia eccezione se il numero supera i limiti.
 */
template <class tipo>
void string2int(string numero, char segno, tipo *num) {
    u8 lung;
    char ch;
    tipo temp, ris=0;
    tipo pow[]={1,          //1e0
               10,          //1e1
               100,         //1e2
               1000,        //1e3
               10000,       //1e4
               100000,      //1e5
               1000000,     //1e6
               10000000,    //1e7
               100000000,   //1e8
               1000000000}; //1e9

    lung=numero.length();
    //Trasforma la stringa in numero
    for(u8 i=1; i<=lung; i++) {
        ch=numero[lung-i];
        temp=((tipo)ch-0x30)*pow[i-1];
        ris+=temp;
    }
    //Cambia il segno se negativo
    if(segno=='-') {
        ris*=-1;
    }
    //Salva il risultato all'indirizzo fornito
    *num=ris;
}



/** FUNZIONI DI CONVERSIONE NUM=>STR **/

string int2string(u8 num, bool noCentinaia=false);


#endif // CHARUTILS_H_INCLUDED
