#include "Errore.h"


/** CLASSE Errore: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - pone a zero tutti i codici.
 */
Errore::Errore(void) {
    errClass=ERR_CL_NULL;
    errOper=ERR_OP_NULL;
    errType=ERR_TP_NULL;
    numElem=0;
    fileStat=FILE_ST_OK;
    errFileOp=ERR_FO_NULL;
}

/* Costruttore:
 * - inizializza due codici (file), pone a zero gli altri.
 */
Errore::Errore(FileStat _fileStat, ErrFileOp _errFileOp) {
    errClass=ERR_CL_NULL;
    errOper=ERR_OP_NULL;
    errType=ERR_TP_NULL;
    numElem=0;
    fileStat=_fileStat;
    errFileOp=_errFileOp;
}

/* Costruttore:
 * - inizializza due codici (err), pone a zero gli altri.
 */
Errore::Errore(ErrOper _errOper, ErrType _errType) {
    errClass=ERR_CL_NULL;
    errOper=_errOper;
    errType=_errType;
    numElem=0;
    fileStat=FILE_ST_OK;
    errFileOp=ERR_FO_NULL;
}

/* Costruttore:
 * - inizializza tre codici (err), pone a zero gli altri.
 */
Errore::Errore(ErrClass _errClass, ErrOper _errOper, ErrType _errType) {
    errClass=_errClass;
    errOper=_errOper;
    errType=_errType;
    numElem=0;
    fileStat=FILE_ST_OK;
    errFileOp=ERR_FO_NULL;
}

/* Costruttore:
 * - inizializza quattro codici (err), pone a zero gli altri.
 */
Errore::Errore(ErrClass _errClass, ErrOper _errOper, ErrType _errType, u16 _numElem) {
    errClass=_errClass;
    errOper=_errOper;
    errType=_errType;
    numElem=_numElem;
    fileStat=FILE_ST_OK;
    errFileOp=ERR_FO_NULL;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE Errore: ASSEGNAMENTO **/

/* Aggiunge il codice relativo alla classe:
 */
void Errore::setErrClass(ErrClass _errClass) {
    errClass=_errClass;
}

/* Aggiunge il codice relativo all'operazione:
 */
void Errore::setErrOper(ErrOper _errOper) {
    errOper=_errOper;
}

/* Aggiunge il codice relativo alla causa:
 */
void Errore::setErrType(ErrType _errType) {
    errType=_errType;
}

/* Aggiunge il numero dell'elemento chiamante:
 */
void Errore::setNumElem(u16 _numElem) {
    numElem=_numElem;
}

/* Aggiunge il codice di errore relativo all'operazione sul file:
 */
void Errore::setErrFileOp(ErrFileOp _errFileOp) {
    errFileOp=_errFileOp;
}

/* Aggiunge il codice di errore relativo allo stato del file:
 */
void Errore::setFileStat(FileStat _fileStat) {
    fileStat=_fileStat;
}



/** CLASSE Errore: INTERROGAZIONE **/

/* Restituisce il primo codice:
 */
ErrClass Errore::getErrClass(void) {
    return errClass;
}

/* Restituisce il secondo codice:
 */
ErrOper Errore::getErrOper(void) {
    return errOper;
}

/* Restituisce il terzo codice:
 */
ErrType Errore::getErrType(void) {
    return errType;
}

/* Restituisce il quarto codice:
 */
u16 Errore::getNumElem(void) {
    return numElem;
}

/* Restituisce il quintocodice:
 */
FileStat Errore::getFileStat(void) {
    return fileStat;
}

/* Restituisce il sesto codice:
 */
ErrFileOp Errore::getErrFileOp(void) {
    return errFileOp;
}
