#ifndef ERRORE_H_INCLUDED
#define ERRORE_H_INCLUDED

//#include <iostream>
#include "Tipi.h"


using namespace std;



/** CLASSI PER LANCIARE ERRORI con throw **/

/* Questa classe rappresenta un errore da lanciare:
 * - contiene le informazioni necessarie per descrivere e trovare l'errore.
 */
class Errore {
    public:
        //Costruttore e distruttore
        Errore(void);
        Errore(FileStat _fileStat, ErrFileOp _errFileOp);
        Errore(ErrOper _errOper, ErrType _errType);
        Errore(ErrClass _errClass, ErrOper _errOper, ErrType _errType);
        Errore(ErrClass _errClass, ErrOper _errOper, ErrType _errType, u16 _numElem);
        ~Errore(void) { };
        //Aggiunge le informazioni mancanti
        void setErrClass(ErrClass _errClass);
        void setErrOper(ErrOper _errOper);
        void setErrType(ErrType _errType);
        void setNumElem(u16 _numElem);
        void setErrFileOp(ErrFileOp _errFileOp);
        void setFileStat(FileStat _fileStat);
        //Restituisce il codice dell'errore
        ErrClass getErrClass(void); //Who
        u16 getNumElem(void); //Who-2
        ErrOper getErrOper(void); //When
        ErrType getErrType(void); //Why
        FileStat getFileStat(void); //Why-2
        ErrFileOp getErrFileOp(void); //When-2

    private:
        //Informazioni sull'errore
        ErrClass errClass; //Indica 'chi' ha lanciato l'errore
        ErrOper errOper; //Indica 'quando'  stato lanciato l'errore
        ErrType errType; //Indica 'perch'  stato lanciato l'errore
        u16 numElem; //Negli errori relativi alle liste, indica quale elemento ha lanciato l'errore
        //Informazioni sullo stato del file
        FileStat fileStat; //Qui salva lo stato del file
        ErrFileOp errFileOp; //Qui indica quale operazione sul file ha generato l'errore
};


#endif // ERRORE_H_INCLUDED
