#ifndef FILEUTF16IN_H_INCLUDED
#define FILEUTF16IN_H_INCLUDED

//#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>

#include "Tipi.h"
#include "Errore.h"
#include "CharUtils.h"


using namespace std;



/** CLASSE PER LA LETTURA DEL FILE UNICODE **/

class FileUtf16in {

  public:
    //Costruttore e distruttore
    FileUtf16in(void) { };
    ~FileUtf16in(void) { };
    //Apre e chiude il file
    void open(const char filename[]);
    void close(void);
    //Lettura dati
    void readChar(char *ch); //Legge un carattere (scarta il byte di ordine inferiore)
    void readString(string *str); //Legge una stringa (come sopra), sulla stessa riga
    void readInt(s32 *num); //Legge un intero con segno 32bit
    void readInt(u32 *num); //Legge un intero senza segno 32bit
    void readInt(s16 *num); //Legge un intero con segno 16bit
    void readInt(u16 *num); //Legge un intero senza segno 16bit
    void readInt(s8 *num); //Legge un intero con segno 8bit
    void readInt(u8 *num); //Legge un intero senza segno 8bit
    void readFloat(f32 *num); //Legge un numero float
    //Salta un campo
    void skip(u8 n=1);
    //Ricerca stringhe
    u8 findString(char str[]); //Ricerca una stringa
    u8 findString(char str1[], char str2[]); //Trova una delle due stringhe
    u8 findString(char str1[], char str2[], char str3[]); //Trova una delle tre stringhe

  private:
    FILE *file;
    //Restituisce lo stato dello stream
    FileStat getFileStat(void);
};

#endif // FILEUTF16IN_H_INCLUDED
