#ifndef MATHUTILS_H_INCLUDED
#define MATHUTILS_H_INCLUDED


#include <cmath>
#include <iostream>
#include <iomanip>

#include "Tipi.h"
//#include "Errore.h"
#include "Vettori.h"


using namespace std;

/** COSTANTI **/

#define piGreco 3.141592654f


/** OPERAZIONI CON I VETTORI **/
/* Hanno senso con tipo == float or double */

template<class tipo> tipo norma(Vett3<tipo> *v);
template<class tipo> void normalizza(Vett3<tipo> *v);
template<class tipo> tipo prodScal(Vett3<tipo> *v, Vett3<tipo> *w);
template<class tipo> tipo prodScalNorm(Vett3<tipo> *v, Vett3<tipo> *w);
template<class tipo> void prodVett(Vett3<tipo> *v, Vett3<tipo> *w, Vett3<tipo> *ris);



/** OPERAZIONI CON LE MATRICI **/
/* Hanno senso con tipo == float or double */

/* 4x4 */
template<class tipo> void prodRxC(Matr4x4<tipo> *a, Matr4x4<tipo> *b, Matr4x4<tipo> *c);
template<class tipo> void copyMatr(Matr4x4<tipo> *in, Matr4x4<tipo> *out);

/* 3x3 */
template<class tipo> void prodRxC(Matr3x3<tipo> *a, Matr3x3<tipo> *b, Matr3x3<tipo> *c);
template<class tipo> tipo det(Matr3x3<tipo> *a);



/** OPERAZIONI GEOMETRICHE CON MATRICI e VETTORI **/
/* Hanno senso con tipo == float or double */

template<class tipo> void trasfVett(Matr4x4<tipo> *trasf, Vett3<tipo> *vettIn, Vett3<tipo> *vettOut);
template<class tipo> void matr2angleAxis(Matr4x4<tipo> *matr, Vett4<tipo> *vett);
template<class tipo> void angleAxis2matr(Vett4<tipo> *vett, Matr3x3<tipo> *dcm);
template<class tipo> void quat2angleAxis(Vett4<tipo> *quat, Vett4<tipo> *vett);
template<class tipo> void angleAxis2quat(Vett4<tipo> *vett, Vett4<tipo> *quat);
//template<class tipo> void matr2quat(Matr4x4<tipo> *matr, Vett4<tipo> *quat);
//template<class tipo> void prodQuat(Vett4<tipo> *a, Vett4<tipo> *b, Vett4<tipo> *c);
template<class tipo> void diffQuat(Vett4<tipo> *a, Vett4<tipo> *b, Vett4<tipo> *c);

template<class tipo> void matr2quat(Matr4x4<tipo> *matr, Vett4<tipo> *quat, Vett3<tipo> *trasl);
template<class tipo> void quat2matr(Vett4<tipo> *quat, Vett3<tipo> *trasl, Matr4x4<tipo> *matr);
template<class tipo> void conjQuat(Vett4<tipo> *quatIn, Vett4<tipo> *quatOut=NULL);
template<class tipo> void prodQuat(Vett4<tipo> *a, Vett4<tipo> *b, Vett4<tipo> *c);



#endif // MATHUTILS_H_INCLUDED
