#include "TSclass.h"


/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'point' o 'vector': CLASSE TSvector
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSI TSvector: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSvector::save(FileUtf16in *file, char delim[]) {
    if(file->findString(delim)==1) {
        f32 _x=0.0f, _y=0.0f, _z=0.0f;
        file->readFloat(&_x);
        file->readFloat(&_y);
        file->readFloat(&_z);
        set(_x, _y, _z); //NB: inversione y <-> z ANNULLATO!
    }
    else {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'uv_point': CLASSE TSuvPoint
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSI TSpoint: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSuvPoint::save(FileUtf16in *file) {
    if(file->findString("uv_point ( ")==1) {
        f32 _u=0.0f, _v=0.0f;
        file->readFloat(&_u);
        file->readFloat(&_v);
        //_v=1-_v; //NB: inversione y <-> z ANNULLATO!
        set(_u, _v);
    }
    else {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER for STRING: CLASSE TSstring
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSstring: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
string TSstring::getString(void) {
    return str;
}


/** CLASSI TSstring: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - riceve anche il delimitatore da cercare;
 * - in caso di errori lancia un'eccezione.
 */
void TSstring::save(FileUtf16in *file, char delim[]) {
    if(file->findString(delim)==1) {
        //string str;
        file->readString(&str);
        //assign(str);
    }
    else {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'matrix': CLASSE TSobject
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSobject: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore: (per memoria)
 * - nothing to do.
 */

/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSobject: ASSEGNAZIONE **/
//Eliminato (per memoria)


/** CLASSE TSobject: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
string TSobject::getObjName(void) {
    return objName;
}

Matr4x4<f32> *TSobject::getMatr(void) {
    return &matr;
}



/** CLASSI TSobject: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSobject::save(FileUtf16in *file) {
    if(file->findString("matrix ")==1) {
        file->readString(&objName); //Se  assente, in matName resta solo una parentesi
        if(objName=="(") {
            //Il nome non era presente (in realt dovrebbe sempre esserci)
            objName.erase();
        }
        else {
            //Era presente il nome => resta da togliere la parentesi
            file->readChar(NULL); //Salta la parentesi
            file->readChar(NULL); //Salta lo spazio
        }
        f32 v[]={0.0f,0.0f,0.0f,
                  0.0f,0.0f,0.0f,
                  0.0f,0.0f,0.0f,
                  0.0f,0.0f,0.0f};
        for(u8 i=0; i<12; i++) {
            file->readFloat(&v[i]);
        }

        //NB: inversione y <-> z: si deve invertire II <-> III colonna
        /*  Matr. letta        inv. colonne
            11  12  13          11  13  12  |
            21  22  23    =>    21  23  22  |-> rotazione
            31  32  33          31  33  32  |
            41  42  43          41  43  42  --> traslazione

            Infatti occorre moltiplicare per la matrice di trasformazione:
               rot 90 asse x   *  specchio asse z  =  matr trasformazione
                                        =                   =
                                  scala -1 asse z     scambio II e III col
             | 1   0   0   0 |   | 1   0   0   0 |    | 1   0   0   0 |
             | 0   0  -1   0 | * | 0   1   0   0 | =  | 0   0   1   0 |
             | 0   1   0   0 |   | 0   0  -1   0 |    | 0   1   0   0 |
             | 0   0   0   1 |   | 0   0   0   1 |    | 0   0   0   1 |
        */
        matr.set(v[0],    v[1],   v[2], 0.0f,
                 v[3],    v[4],   v[5], 0.0f,
                 v[6],    v[7],   v[8], 0.0f,
                 v[9],   v[10],  v[11], 1.0f);
        /*matr.set(+v[0],   - v[1],  - v[2], 0.0f,
                 -v[3],   + v[4],  - v[5], 0.0f,
                 -v[6],   - v[7],  + v[8], 0.0f,
                 +v[9],   +v[10],  +v[11], 1.0f);*/
        /*matr.set(v[0],    v[2],   v[1], 0.0f,
                 v[3],    v[5],   v[4], 0.0f,
                 v[6],    v[8],   v[7], 0.0f,
                 v[9],   v[11],  v[10], 1.0f);*/
    }
    else {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'texture': CLASSE TStexture
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TStexture: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TStexture::TStexture(void) {
    imageIdx=0;
    filterModeIdx=0;
    mipMapLevel=0;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TStexture: ASSEGNAMENTO **/

/* Assegna tutte le variabili:
 */
void TStexture::set(u8 _imageIdx, u8 _filterModeIdx, s8 _mipMapLevel) {
    imageIdx=_imageIdx;
    filterModeIdx=_filterModeIdx;
    mipMapLevel=_mipMapLevel;
}


/* Assegna una variabile per volta:
 */
void TStexture::setImageIdx(u8 _imageIdx) {
    imageIdx=_imageIdx;
}

void TStexture::setFilterIdx(u8 _filterModeIdx) {
    filterModeIdx=_filterModeIdx;
}

void TStexture::setMipLevel(f32 _mipMapLevel) {
    _mipMapLevel=_mipMapLevel;
}



/** CLASSE TStexture: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
u8 TStexture::getImageIdx(void) {
    return imageIdx;
}

u8 TStexture::getFilterIdx(void) {
    return filterModeIdx;
}

f32 TStexture::getMipLevel(void) {
    return mipMapLevel;
}



/** CLASSI TStexture: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TStexture::save(FileUtf16in *file) {
    if(file->findString("texture ( ")==1) {
        file->readInt(&imageIdx);
        file->readInt(&filterModeIdx);
        file->readFloat(&mipMapLevel);
    }
    else {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'vtx_state': CLASSE TSvtxState
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSvtxState: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TSvtxState::TSvtxState(void) {
    objectIdx=0;
    matShining=0;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSvtxState: ASSEGNAMENTO **/

/* Assegna tutte le variabili:
 */
void TSvtxState::set(u8 _objectIdx, s8 _matShining) {
    objectIdx=_objectIdx;
    matShining=_matShining;
}


/* Assegna una variabile per volta:
 */
void TSvtxState::setObjectIdx(u8 _objectIdx) {
    objectIdx=_objectIdx;
}

void TSvtxState::setMatShining(s8 _matShining) {
    matShining=_matShining;
}



/** CLASSE TSvtxState: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
u8 TSvtxState::getObjectIdx(void) {
    return objectIdx;
}

s8 TSvtxState::getMatShining(void) {
    return matShining;
}



/** CLASSI TSvtxState: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSvtxState::save(FileUtf16in *file) {
    if(file->findString("vtx_state ( ")==1) {
        file->skip(1); //Salta 'dword,flags'
        file->readInt(&objectIdx);
        file->readInt(&matShining);
    }
    else {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'prim_state': CLASSE TSprimState
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSprimState: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TSprimState::TSprimState(void) {
    //name: nothing to do
    shaderIdx=0;
    textureIdx=0;
    vtxStateIdx=0;
    alphaMode=0;
    lightCfgIdx=0;
    zBuffMode=0;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSprimState: ASSEGNAMENTO **/

/* Assegna tutte le variabili:
 */
void TSprimState::set(string _matName, u8 _shaderIdx, u8 _textureIdx, u8 _vtxStateIdx,
                        u8 _alphaMode, u8 _lightCfgIdx, u8 _zBuffMode) {
    matName=_matName;
    shaderIdx=_shaderIdx;
    textureIdx=_textureIdx;
    vtxStateIdx=_vtxStateIdx;
    alphaMode=_alphaMode;
    lightCfgIdx=_lightCfgIdx;
    zBuffMode=_zBuffMode;
    hasTexture=false;
}


/* Assegna il numero del materiale
 */
void TSprimState::setNumMat(u16 _numMat) {
    numMat=_numMat;
}


/** CLASSE TSprimState: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
string TSprimState::getMatName(void) {
    return matName;
}

u8 TSprimState::getShaderIdx(void) {
    return shaderIdx;
}

u8 TSprimState::getTextureIdx(void) {
    return textureIdx;
}

u8 TSprimState::getVtxStateIdx(void) {
    return vtxStateIdx;
}

u8 TSprimState::getAlphaMode(void) {
    return alphaMode;
}

u8 TSprimState::getLightCfgIdx(void) {
    return lightCfgIdx;
}

u8 TSprimState::getZBuffMode(void) {
    return zBuffMode;
}

u16 TSprimState::getNumMat(void) {
    return numMat;
}

bool TSprimState::getHasTexture(void) {
    return hasTexture;
}



/** CLASSI TSprimState: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSprimState::save(FileUtf16in *file) {
    if(file->findString("prim_state ")!=1) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
    file->readString(&matName); //Se  assente, in matName resta solo una parentesi
    if(matName=="(") {
        //Il nome non era presente
        matName.erase();
    }
    else {
        //Era presente il nome => salto la parentesi successiva
        file->readChar(NULL); //Salta la parentesi
    }
    file->readChar(NULL); //Salta lo spazio
    file->skip(1); //Salta 'dword,flags'
    file->readInt(&shaderIdx);
    if(file->findString("tex_idxs ( ")!=1) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_3);
    }
    u8 numTex=0;
    file->readInt(&numTex);
    if(numTex==0) {
        //Il materiale non ha texture
        hasTexture=false;
    }
    else if(numTex==1) {
        //Il materiale ha una texture
        file->readInt(&textureIdx);
        hasTexture=true;
    }
    else {
        //Numero di texture inatteso
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM);
    }
    file->readChar(NULL); //Salta la parentesi
    file->readChar(NULL); //Salta lo spazio
    file->skip(1); //Salta 'float,zBias'
    file->readInt(&vtxStateIdx);
    file->readInt(&alphaMode);
    file->readInt(&lightCfgIdx);
    file->readInt(&zBuffMode);
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'vertices': CLASSE TSvertex
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSvertex: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TSvertex::TSvertex(void) {
    pointIdx=0;
    uvPointIdx=0;
    isDupl=false;
    eqVertexIdx=0;
    //colour.set(0,0,0,0);
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSvertex: ASSEGNAMENTO **/

/* Assegna tutte le variabili:
 */
void TSvertex::set(u16 _pointIdx, u16 _normalIdx, u16 _uvPointIdx) {
    pointIdx=_pointIdx;
    normalIdx=_normalIdx;
    uvPointIdx=_uvPointIdx;
    //colour=_colour;
}


/* Assegna una variabile per volta:
 */
void TSvertex::setPointIdx(u16 _pointIdx) {
    pointIdx=_pointIdx;
}

void TSvertex::setNormalIdx(u16 _normalIdx) {
    normalIdx=_normalIdx;
}

void TSvertex::setUvPointIdx(u16 _uvPointIdx) {
    uvPointIdx=_uvPointIdx;
}



/** CLASSE TSvertex: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
u16 TSvertex::getPointIdx(void) {
    return pointIdx;
}

u16 TSvertex::getNormalIdx(void) {
    return normalIdx;
}

u16 TSvertex::getUvPointIdx(void) {
    return uvPointIdx;
}



/** CLASSE TSvertex: ORGANIZZAZIONE **/

/* Assegna il valore:
 */
void TSvertex::setIsDupl(bool _isDupl) {
    isDupl=_isDupl;
}

void TSvertex::setEqVertexIdx(u16 _eqVertexIdx) {
    eqVertexIdx=_eqVertexIdx;
}


/* Restituisce il valore:
 */
bool TSvertex::getIsDupl(void) {
    return isDupl;
}

u16 TSvertex::getEqVertexIdx(void) {
    return eqVertexIdx;
}



/** CLASSI TSvertex: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSvertex::save(FileUtf16in *file) {
    if(file->findString("vertex ( ")!=1) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
    //Ha trovato il vertex
    file->skip(1); //Salta 'dword,flags'
    file->readInt(&pointIdx);
    file->readInt(&normalIdx);
    //todo: colour
    if(file->findString("vertex_uvs ( ")!=1) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_3);
    }
    //Ha trovato vertex_vus
    u8 numUv=0;
    file->readInt(&numUv);
    if(numUv==1) {
        //Normalmente ci si apsetta un solo vertex_uv
        file->readInt(&uvPointIdx);
    }
    else if(numUv==0) {
        //Nel caso di materiali senza texture, alcuni vertici non hanno coordinate uv
        uvPointIdx=0;
    }
    else {
        //Numero di vertici uvs inatteso
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM);
    }

}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'primitives': CLASSE TSface
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSface: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TSface::TSface(void) {
    verticesIdx[0]=0;
    verticesIdx[1]=0;
    verticesIdx[2]=0;
    normalIdx=0;
    primStateIdx=0;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSface: ASSEGNAMENTO **/

/* Assegna tutte le variabili:
 */
void TSface::set(u16 _verticesIdx[], u16 _normalIdx, u8 _primStateIdx) {
    verticesIdx[0]=_verticesIdx[0];
    verticesIdx[1]=_verticesIdx[1];
    verticesIdx[2]=_verticesIdx[2];
    normalIdx=_normalIdx;
    primStateIdx=_primStateIdx;
}


/* Assegna una variabile per volta:
 */
void TSface::setVerticesIdx(u16 _verticesIdx[]) {
    verticesIdx[0]=_verticesIdx[0];
    verticesIdx[1]=_verticesIdx[1];
    verticesIdx[2]=_verticesIdx[2];
}

void TSface::setVerticesIdx(u8 n, u16 vertexIdx) {
    if(n>3) {
        //Eccede i limiti dell'array
        throw Errore(ERR_CL_TS_FACE, ERR_OP_SET_VAL, ERR_TP_EXCEED_ARRAY);
    }
    verticesIdx[n]=vertexIdx;
}

void TSface::setNormalIdx(u16 _normalIdx) {
    normalIdx=_normalIdx;
}

void TSface::setPrimStateIdx(u8 _primStateIdx) {
    primStateIdx=_primStateIdx;
}



/** CLASSE TSface: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
u16 *TSface::getVerticesIdx(void) {
    return verticesIdx;
}

u16 TSface::getVerticesIdx(u8 n) {
    if(n>3) {
        //Eccede i limiti dell'array
        throw Errore(ERR_CL_TS_FACE, ERR_OP_RETURN_VAL, ERR_TP_EXCEED_ARRAY);
    }
    return verticesIdx[n-1];
}

u16 TSface::getNormalIdx(void) {
    return normalIdx;
}

u8 TSface::getPrimStateIdx(void) {
    return primStateIdx;
}



/** CLASSI TSface: SALVA DATI DA FILE **/

/* Non si pu usare la funzione 'save' perch la facce sono salvate in modo
 * differente rispetto agli altri dati.
 * (per memoria)
 */





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'distance_level': CLASSE TSlod
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSvertex: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TSlod::TSlod(void) {
    distance=0.0f;
    tsVertices.setErrCode(ERR_CL_TS_VERTEX);
    tsFaces.setErrCode(ERR_CL_TS_FACE);
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSlod: ASSEGNAMENTO **/

/* Assente.
 */



/** CLASSE TSlod: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
TSvertex *TSlod::getPVertex(u8 n) {
    return tsVertices.getElem(n);
}

TSface *TSlod::getPFace(u8 n) {
    return tsFaces.getElem(n);
}

s8 TSlod::getHierarchy(u8 n) {
    return *hierarchy.getElem(n);
}

f32 TSlod::getDistance(void) {
    return distance;
}



/** CLASSI TSlod: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - controlla i vertici duplicati (operazione eseguita in fase di lettura per ridurre
     il costo computazionale);
 * - in caso di errori lancia un'eccezione.
 */
#ifdef CONSOLE
void TSlod::save(FileUtf16in *file)
#else
void TSlod::save(FileUtf16in *file, ProgressDialog &pgsDlg)
#endif
{
    //Inizializzazione sotto-liste (per sicurezza)
    tsVertices.eraseAll(); //Svuota la lista (o fa nulla se  gi vuota)
    tsFaces.eraseAll(); //Svuota la lista (o fa nulla se  gi vuota)
    /* --------- *
     *  TESTATA  *
     * --------- */
    //Cerca l'inizio del LOD
    if(file->findString("distance_level_header (")==0) { //NB: non c' lo spazio dopo la parentesi
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
    //Ha trovato l'inizio del LOD => cerca la distanza di attivazione
    if(file->findString("dlevel_selection ( ")==0) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_3);
    }
    //Ha trovato la distanza => la legge
    file->readFloat(&distance);
    //Adesso cerca la dichiarazione della gerarchia
    if(file->findString("hierarchy ( ")==0) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_4);
    }
    //Ha trovato la gerarchia => legge il numero di oggetti
    u8 numObj=0;
    file->readInt(&numObj);
    if(numObj==0) {
        //Numero di oggetti==0: impossibile!
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM);
    }
    //Ora legge i codici di gerarchia degli oggetti
    for(u8 i=0; i<numObj; i++) {
        file->readInt(hierarchy.addElem());
    }

    /* ----------- *
     *  GEOMETRIA  *
     * ----------- */
    //Cerca l'elenco dei subobject
    if(file->findString("sub_objects ( ")==0) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_5);
    }
    //Ha trovato l'inizio dei subobjects => legge quanti sono
    u8 numSubObj=0;
    u16 contaVertices=0, contaFaces=0; //Queste variabili conservano il valore tra i vari subobjects
    file->readInt(&numSubObj);
    if(numSubObj==0) {
        //Numero di subobjects==0: impossibile!
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM_2);
    }
    //Adesso legge la sezione subobjects
    for(u8 i=0; i<numSubObj; i++) {
        u8 numCull=0;
        u16 numVertices=0, totVertices=0, numPrims=0, numFacesSubObj=0, numFacesLette=0, temp=0, mem=0;
        /* --------------------------- *
         *  SUBOBJECT: geometry_nodes  *
         * --------------------------- */
        //Legge il numero di facce contenute in totale nel subbobject. Si ricava leggendo
        // la sezione 'geometry_nodes' di ogni subobject, sommando le seconde (o le terze)
        // componenti di 'cullable_primis'. Si potrebbe anche gi sapere quante 'indexed_trilist'
        // verranno incontrate (prima componente di 'cullable_primis')
        if(file->findString("geometry_nodes ( ")==0) {
            //Non ha trovato il delimitatore
            throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_6);
        }
        //Ha trovato l'elenco delle 'cullable_primis' => legge quante sono
        file->readInt(&numCull);
        if(numCull==0) {
            //Numero di cull==0: impossibile!
            throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM_3);
        }
        //Azzera il numero di facce e prims del subobject
        numFacesLette=0;
        numFacesSubObj=0;
        numPrims=0;
        //Ora legge la sezione 'geometry_nodes'
        for(u16 j=0; j<numCull; j++) {
            if(file->findString("cullable_prims ( ")==0) {
                //Non ha trovato il delimitatore
                throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_7);
            }
            //Numero prims
            file->readInt(&temp);
            numPrims+=temp;
            //Numero faces
            file->readInt(&temp);
            numFacesSubObj+=temp;
        }
        /* --------- *
         *  VERTICI  *
         * --------- */
        //Cerca l'elenco dei vertici dell'i-esimo subobject
        if(file->findString("vertices ( ")==0) {
            //Non ha trovato il delimitatore
            throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_8);
        }
        //Ha trovato l'elenco dei vertici => legge quanti sono
        file->readInt(&numVertices);
        if(numVertices==0) {
            //Numero di vertici==0: impossibile!
            throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM_4);
        }
        #ifndef CONSOLE
        //Inizializza
        pgsDlg.startOperation(5.0f/(numVertices*numSubObj), "Parsing shape file: reading vertices...", false);
        #endif
        //Legge l'elenco dei vertici
        for(u16 j=0; j<numVertices; j++) {
            try {
                //Legge e salva un oggetto tipo TSvertex
                tsVertices.addElem()->save(file);
            }
            catch(Errore err) {
                //Aggiunge le informazioni sulla classe e poi rilancia l'errore
                err.setErrClass(tsVertices.getErrCode());
                err.setNumElem(i+1);
                throw err;
            }
            #ifndef CONSOLE
            //Incrementa la progress bar
            pgsDlg.incrementStep();
            #endif
        }
        //Controlla la lista appena riempita
        mem=tsVertices.check();
        totVertices=contaVertices+numVertices;
        //mem-=contaVertices;
        if(mem!=totVertices) {
            //Lunghezza==0
            throw Errore(tsVertices.getErrCode(), ERR_OP_SAVE_DATA, ERR_TP_DIFF_LENGTH);
        }
        //Ha completato l'elenco dei vertex
        //Prima di proseguire nella lettura del file con le facce, ripercorre la lista dei vertici
        // appena creata per individuare i vertici duplicati (cio i vertex che hanno uguale
        // pointIdx e uvPointIdx, anche se hanno diversa normale); questo permette di velocizzare
        // la fase di importazione dei vertici nella mesh.
        // Il ciclo  tra contaVertices e numVertices per lavorare solo i vertex appena aggiunti
        TSvertex *theVertex=NULL, *oneVertex=NULL;
        u16 newVertexIdx=0;
        #ifndef CONSOLE
        //Inizializza la barra
        pgsDlg.startOperation(40.0f/(numVertices*numSubObj), "Parsing shape file: checking vertices...", false);
        #endif
        for(u16 j=contaVertices; j<totVertices; j++) {
            theVertex=tsVertices.getElem(j);
            //Cerca tra i precedenti nell'elenco se ce n' uno uguale
            for(u16 k=j; k!=0; k--) {
                oneVertex=tsVertices.getElem(k-1);
                if(theVertex->getPointIdx()==oneVertex->getPointIdx()) {
                    //I due vertex hanno in comune il punto 3D
                    if(theVertex->getUvPointIdx()==oneVertex->getUvPointIdx()) {
                        //I due vertex hanno in comune anche il punto uv => sono uguali!
                        theVertex->setIsDupl(true);
                        //NB: non mette soltanto setEqVertexIdx(k) perch scorre la lista dei vertices
                        // al contrario e quindi k-1 trova l'ultimo vertex uguale in lista; questo, se 
                        // duplicato contiene il numero del primo vertex uguale in lista.
                        if(oneVertex->getIsDupl()==true) {
                            newVertexIdx=oneVertex->getEqVertexIdx();
                        }
                        else newVertexIdx=k-1;
                        theVertex->setEqVertexIdx(newVertexIdx);
                        //Passa al prossimo vertex (j+1)
                        break;
                    }
                    //else: uvPoiuntIdx differente => non  duplicato!
                }
                //else: pointIdx differente => non  duplicato!
                // Passa al confronto con il precedente vertex in lista (k-1)
            }
            //Vertex j analizzato; passa al prossimo (j+1)
            #ifndef CONSOLE
            //Incrementa la progress bar
            pgsDlg.incrementStep();
            #endif
        }
        //ContaVertices deve essere aggiornato dopo la lettura delle facce!

        /* ------- *
         *  FACCE  *
         * ------- */
        //Cerca l'elenco delle primitives dell'i-esimo subobject
        if(file->findString("primitives ( ")==0) {
            //Non ha trovato il delimitatore
            throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_9);
        }
        //Legge l'elenco delle primitives
        //Ogni primitiv contiene:
        // - una sezione prim_state_idx => numero del prim_state da applicare alle facce seguenti;
        // - una o pi sezioni indexed_trilist => elenco facce (vertici e normali).
        //Si pu sfruttare il delimitatore 'sub_object' del successivo subobject per riconoscere la
        // fine del subobject perch non  necessario per riconoscere il subobject successivo (infatti
        // usa un ciclo for e cerca per prima cosa 'vertices', vedi sopra).
        //Poich si lavora con pi elenchi di facce occorre tener conto delle facce gi memorizzate
        // utilizzando la variabile contaFaces, che va dichiarato prima, insieme a contaVertices per
        // conservarne il valore tra un subobject e l'altro.
        u8 primLette=0, primStateIdx=0;
        u16 numTerne=0, numNorm=0;
        bool go=true;
        while(go) {
            //Cerca uno dei due delimitatori. NB: il secondo senza spazio finale!!!
            u8 quale=0;
            quale=file->findString("prim_state_idx ( ", "indexed_trilist (");
            if(quale==0) {
                //Non ha trovato alcuno dei tre delimitatori
                throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_10);
            }
            else if(quale==1) {
                /* ----------------------- *
                 *  FACCE: prim_state_idx  *
                 * ----------------------- */
                //Legge il numero del prim_state da applicare
                file->readInt(&primStateIdx);
                //Prosegue con il ciclo
            }
            else if(quale==2) {
                /* ------------------------ *
                 *  FACCE: indexed_trilist  *
                 * ------------------------ */
                //Ha trovato 'indexed_trilist'
                //Controllo
                primLette++;
                if(primLette>numPrims) { //NB: vale esattamente = e non < perch per la I prim vale primLette=1
                    //Ha trovato 'prim_state_idx' ma era inatteso
                    throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXP_DELIM);
                }
                //Salva la definizione delle facce
                //Cerca l'elenco delle terne dei vertici
                if(file->findString("vertex_idxs ( ")==0) {
                    //Non ha trovato il delimitatore
                    throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_11);
                }
                //Salva il numero di terne dei vertici (nel file leggo il num di vertici)
                file->readInt(&numTerne);
                numTerne/=3;
                if(numTerne==0) {
                    //Numero di primitives==0: impossibile!
                    throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM_5);
                }
                #ifndef CONSOLE
                //Inizializza la barra
                pgsDlg.startOperation(5.0f/(numFacesSubObj*numSubObj), "Parsing shape file: reading faces...", false);
                #endif
                //Legge e salva l'elenco dei vertici di ogni faccia, creando la lista.
                for(u16 j=0; j<numTerne; j++) {
                    u16 vertexIdx[3];
                    //Legge i vertexIdx
                    file->readInt(&vertexIdx[0]);
                    file->readInt(&vertexIdx[1]);
                    file->readInt(&vertexIdx[2]);
                    //Tiene conto dei vertici dei subobjects precedenti del medesimo LOD
                    vertexIdx[0]+=contaVertices;
                    vertexIdx[1]+=contaVertices;
                    vertexIdx[2]+=contaVertices;
                    //Ora controlla se i vertex sono duplicati
                    for(u8 k=0; k<3; k++) {
                        oneVertex=tsVertices.getElem(vertexIdx[k]);
                        if(oneVertex->getIsDupl()==true) {
                            //E' un vertice doppio => sostituisce vertexIdx[k]
                            vertexIdx[k]=oneVertex->getEqVertexIdx();
                        }
                        //Altrimenti non cambia nulla
                    }
                    //Salva la faccia con i vertices originali o modificati (se duplicati)
                    tsFaces.addElem()->setVerticesIdx(vertexIdx);
                    #ifndef CONSOLE
                    //Incrementa la progress bar
                    pgsDlg.incrementStep();
                    #endif
                }
                //Controlla la lista appena riempita
                mem=tsFaces.check(); //Lunghezza lista
                mem-=contaFaces; //Numero di facce aggiunte
                if(mem!=numTerne) {
                    //Lunghezza==0
                    throw Errore(tsFaces.getErrCode(), ERR_OP_SAVE_DATA, ERR_TP_DIFF_LENGTH);
                }
                //Cerca l'elenco delle normali delle facce
                if(file->findString("normal_idxs ( ")==0) {
                    //Non ha trovato il delimitatore
                    throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_12);
                }
                //Salva il numero delle normali presenti in elenco
                //Per qualche oscuro motivo,  presente in elenco anche la normale posteriore
                // (indicata con idx=3 nell'elenco) ma non viene contata nel totale idxs.
                file->readInt(&numNorm);
                if(numNorm==0) {
                    //Numero di primitives==0: impossibile!
                    throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM_6);
                }
                //Controllo sul numero normali - numero facce - numero terne vertici
                if(numNorm!=numTerne) {
                    //Devono essere uguali perch entrambi rappresentano il numero di facce
                    throw Errore(ERR_OP_SAVE_DATA, ERR_TP_UNEXPECTED_NUM_7);
                }
                //Legge e salva l'elenco delle normali di ogni faccia, sfruttando la lista esistente
                #ifndef CONSOLE
                //Inizializza la barra
                pgsDlg.startOperation(5.0f/(numFacesSubObj*numSubObj), "Parsing shape file: reading normals...", false);
                #endif
                for(u16 j=0; j<numNorm; j++) {
                    u16 normalIdx;
                    file->readInt(&normalIdx);
                    //if(primStateIdx==12) cout<<"NormalIdx="<<normalIdx<<endl;
                    file->skip(1); //Scarta la normale posteriore
                    tsFaces.getElem(j+contaFaces)->setNormalIdx(normalIdx);
                    tsFaces.getElem(j+contaFaces)->setPrimStateIdx(primStateIdx);
                    //if(primStateIdx==12) {if(j==100 || j==200) {int p; cin>>p;}}
                    #ifndef CONSOLE
                    //Incrementa la progress bar
                    pgsDlg.incrementStep();
                    #endif
                }
                //if(primStateIdx==12) {int p; cin>>p;}
                //Aggiorna il contatore delle facce lette
                contaFaces+=numNorm;
                //Numero di facce lette in questo subobject
                numFacesLette+=numNorm;
                //Controllo facce lette rispetto a quelle previste
                if(numFacesLette==numFacesSubObj) {
                    //Ha finito questo subobject!
                    go=false;
                }
            }
        } //Fine ciclo while delle facce dell'i-esimo subobject
        //Aggiorna il contatore dei vertici letti (serve per non memorizzare i subobject
        //  mantenendo comunque la corrispondenza tra num vertice elencato nella sezione
        //  facce e num vertex nella sezione vertices).
        contaVertices+=numVertices;
    } //Fine ciclo for subobjects
}



/** FUNZIONI MEMBRO --- RICHIESTA INDIRIZZI LISTE **/

/* Richiesta indirizzi liste private:
 */
Lista<TSvertex> *TSlod::getTSvertices(void) {
    return &tsVertices;
}

Lista<TSface> *TSlod::getTSfaces(void) {
    return &tsFaces;
}

Lista<s8> *TSlod::getHierarchy(void) {
    return &hierarchy;
}



/** CLASSI TSlod: CANCELLA LE LISTE **/

/* Cancella le liste private:
 */
void TSlod::eraseAll() {
    tsVertices.eraseAll();
    tsFaces.eraseAll();
    hierarchy.eraseAll();
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'tcb_key' o 'slerp_rot': CLASSE TSrotKey
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSrotKey: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TSrotKey::TSrotKey(void) {
    numKey=0;
}

/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSrotKey: ASSEGNAZIONE **/
//Eliminato (per memoria)


/** CLASSE TSrotKey: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
u8 TSrotKey::getNumKey(void) {
    return numKey;
}

Vett4<f32> *TSrotKey::getQuat(void) {
    return &quat;
}



/** CLASSI TSrotKey: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSrotKey::save(FileUtf16in *file) {
    //Cerca l'inizio di un rotKey
    if(file->findString("tcb_key ( ", "slerp_rot ( ")==0) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_5);
    }
    //Legge il numero del fotogramma
    file->readInt(&numKey);
    //Legge il quaternione (x,y,z,w)
    f32 q[4];
    for(u8 i=0; i<4; i++) {
        file->readFloat(&q[i]);
    }
    quat.set(-q[0], -q[1], -q[2], q[3]); //Legge -x,-y,-z,w
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'linear_pos': CLASSE TSlinKey
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSlinKey: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
TSlinKey::TSlinKey(void) {
    numKey=0;
}

/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSlinKey: ASSEGNAZIONE **/
//Eliminato (per memoria)


/** CLASSE TSlinKey: INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
u8 TSlinKey::getNumKey(void) {
    return numKey;
}

Vett3<f32> *TSlinKey::getTrasl(void) {
    return &trasl;
}



/** CLASSI TSlinKey: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSlinKey::save(FileUtf16in *file) {
    //Cerca l'inizio di un linKey
    if(file->findString("linear_key ( ")==0) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_6);
    }
    //Legge il numero del fotogramma
    file->readInt(&numKey);
    //Legge il vettore
    f32 q[3];
    for(u8 i=0; i<3; i++) {
        file->readFloat(&q[i]);
    }
    trasl.set(q[0], q[1], q[2]); //NB: inversione y <-> z ANNULLATA!
}




/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** TS CONTAINER 'anim_node': CLASSE TSanimNode
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE TSanimNode: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza codici errore delle liste private.
 */
TSanimNode::TSanimNode(void) {
    tsRotKeys.setErrCode(ERR_CL_TS_ROT_KEY);
    tsLinKeys.setErrCode(ERR_CL_TS_LIN_KEY);
};

/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE TSanimNode: ASSEGNAZIONE **/
//Eliminato (per memoria)


/** CLASSE TSanimNode INTERROGAZIONE **/

/* Restituisce una variabile per volta:
 */
string TSanimNode::getObjName(void) {
    return objName;
}

TSrotKey *TSanimNode::getRotKey(u8 n) {
    return tsRotKeys.getElem(n);
}

TSlinKey *TSanimNode::getLinKey(u8 n) {
    return tsLinKeys.getElem(n);
}

u8 TSanimNode::getNumRotKeys(void) {
    return tsRotKeys.getLung();
}

u8 TSanimNode::getNumLinKeys(void) {
    return tsLinKeys.getLung();
}



/** CLASSI TSanimNode: SALVA DATI DA FILE **/

/* Salva un oggetto:
 * - riceve l'indirizzo dell'oggetto corrispondente al file shape;
 * - in caso di errori lancia un'eccezione.
 */
void TSanimNode::save(FileUtf16in *file) {
    if(file->findString("anim_node ")==0) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_2);
    }
    file->readString(&objName); //Se  assente, in matName resta solo una parentesi
    if(objName=="(") {
        //Il nome non era presente (in realt dovrebbe sempre esserci)
        objName.erase();
    }
    //Legge la sezione controllers
    if(file->findString("controllers ( ")==0) {
        //Non ha trovato il delimitatore
        throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_3);
    }
    u8 numControllers=0;
    file->readInt(&numControllers);
    //se numControllers==0 => l'oggetto non  animato => salta il ciclo e termina
    for(u8 i=0; i<numControllers; i++) {
        u8 quale=0, numKeys=0;
        quale=file->findString("tcb_rot ( ", "tcb_pos ( ","linear_pos ( "); /*CONTROLLARE CON MINUETTO*/
        if(quale==0) {
            //Non ha trovato il delimitatore
            throw Errore(ERR_OP_SAVE_DATA, ERR_TP_MISS_DELIM_4);
        }
        else if(quale==1) {
            //Ha trovato un rotKey; legge quanti sono
            file->readInt(&numKeys);
            tsRotKeys.eraseAll(); //Pulisce la lista (o fa nulla se  gi vuota)
            //Salva l'elenco dei rotKeys
            for(u8 j=0; j<numKeys; j++) {
                try {
                    tsRotKeys.addElem()->save(file);
                }
                catch(Errore err) {
                    //Aggiunge le informazioni e poi rilancia l'errore
                    err.setErrClass(tsRotKeys.getErrCode());
                    err.setNumElem(i+1);
                    throw err;
                }
            }
            //Una volta completata la lista, la controlla
            u8 mem=0;
            mem=tsRotKeys.check();
            if(mem!=numKeys) {
                //Lunghezza==0
                throw Errore(tsRotKeys.getErrCode(), ERR_OP_SAVE_DATA, ERR_TP_DIFF_LENGTH);
            }
        }
        else { // quale==2 || quale==3
            //Ha trovato un linKey
            file->readInt(&numKeys);
            tsLinKeys.eraseAll(); //Pulisce la lista (o fa nulla se  gi vuota)
            for(u8 j=0; j<numKeys; j++) {
                try {
                    tsLinKeys.addElem()->save(file);
                }
                catch(Errore err) {
                    //Aggiunge le informazioni e poi rilancia l'errore
                    err.setErrClass(tsLinKeys.getErrCode());
                    err.setNumElem(i+1);
                    throw err;
                }
            }
            //Una volta completata la lista, la controlla
            u8 mem=0;
            mem=tsLinKeys.check();
            if(mem!=numKeys) {
                //Lunghezza==0
                throw Errore(tsLinKeys.getErrCode(), ERR_OP_SAVE_DATA, ERR_TP_DIFF_LENGTH);
            }
        }
    } //Fine ciclo controllers
}


/** CLASSI TSanimNode: CANCELLA LE LISTE **/

/* Cancella le liste private:
 */
void TSanimNode::eraseAll() {
    tsRotKeys.eraseAll();
    tsLinKeys.eraseAll();
}
