#ifndef VETTORI_CPP_INCLUDED
#define VETTORI_CPP_INCLUDED

#include "Vettori.h"


/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** VETTORE A 4 DIMENSIONI: CLASSE Vett4
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE Vett4: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
template <class tipo>
Vett4<tipo>::Vett4(void) {
    x=0;
    y=0;
    z=0;
    w=0;
}


/* Costruttore con assegnamento:
 * - assegna il valore fornito alle componenti.
 */
template <class tipo>
Vett4<tipo>::Vett4(tipo _x, tipo _y, tipo _z, tipo _w) {
    x=_x;
    y=_y;
    z=_z;
    w=_w;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE Vett4: ASSEGNAMENTO **/

/* Assegna tutte e quattro le componenti (w,x,y,z):
 */
template <class tipo>
void Vett4<tipo>::set(tipo _x, tipo _y, tipo _z, tipo _w) {
    x=_x;
    y=_y;
    z=_z;
    w=_w;
}


/* Assegna la prima componente (x):
 */
template <class tipo>
void Vett4<tipo>::setX(tipo _x) {
    x=_x;
}


/* Assegna la seconda componente (y):
 */
template <class tipo>
void Vett4<tipo>::setY(tipo _y) {
    y=_y;
}


/* Assegna la terza componente (z):
 */
template <class tipo>
void Vett4<tipo>::setZ(tipo _z) {
    z=_z;
}


/* Assegna la quarta componente (w):
 */
template <class tipo>
void Vett4<tipo>::setW(tipo _w) {
    w=_w;
}



/** CLASSE Vett4: INTERROGAZIONE **/

/* Restituisce la prima componente (x):
 */
template <class tipo>
tipo Vett4<tipo>::getX(void) {
    return x;
}


/* Restituisce la seconda componente (y):
 */
template <class tipo>
tipo Vett4<tipo>::getY(void) {
    return y;
}


/* Restituisce la terza componente (z):
 */
template <class tipo>
tipo Vett4<tipo>::getZ(void) {
    return z;
}


/* Restituisce la quarta componente (w):
 */
template <class tipo>
tipo Vett4<tipo>::getW(void) {
    return w;
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** VETTORE A 3 DIMENSIONI: CLASSE Vett3
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE Vett3: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
template <class tipo>
Vett3<tipo>::Vett3(void) {
    x=0;
    y=0;
    z=0;
}


/* Costruttore con assegnamento:
 * - assegna il valore fornito alle componenti.
 */
template <class tipo>
Vett3<tipo>::Vett3(tipo _x, tipo _y, tipo _z) {
    x=_x;
    y=_y;
    z=_z;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE Vett3: ASSEGNAMENTO **/

/* Assegna tutte e tre le componenti (x,y,z):
 */
template <class tipo>
void Vett3<tipo>::set(tipo _x, tipo _y, tipo _z) {
    x=_x;
    y=_y;
    z=_z;
}


/* Assegna la prima componente (x):
 */
template <class tipo>
void Vett3<tipo>::setX(tipo _x) {
    x=_x;
}


/* Assegna la seconda componente (y):
 */
template <class tipo>
void Vett3<tipo>::setY(tipo _y) {
    y=_y;
}


/* Assegna la terza componente (z):
 */
template <class tipo>
void Vett3<tipo>::setZ(tipo _z) {
    z=_z;
}



/** CLASSE Vett3: INTERROGAZIONE **/

/* Restituisce la prima componente (x):
 */
template <class tipo>
tipo Vett3<tipo>::getX(void) {
    return x;
}


/* Restituisce la seconda componente (y):
 */
template <class tipo>
tipo Vett3<tipo>::getY(void) {
    return y;
}


/* Restituisce la terza componente (z):
 */
template <class tipo>
tipo Vett3<tipo>::getZ(void) {
    return z;
}





/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** VETTORE A 2 DIMENSIONI: CLASSE Vett2
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE Vett2: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
template <class tipo>
Vett2<tipo>::Vett2(void) {
    x=0;
    y=0;
}


/* Costruttore con assegnamento:
 * - assegna il valore fornito alle componenti.
 */
template <class tipo>
Vett2<tipo>::Vett2(tipo _x, tipo _y) {
    x=_x;
    y=_y;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE Vett3: ASSEGNAMENTO **/

/* Assegna tutte e tre le componenti (x,y,z):
 */
template <class tipo>
void Vett2<tipo>::set(tipo _x, tipo _y) {
    x=_x;
    y=_y;
}


/* Assegna la prima componente (x):
 */
template <class tipo>
void Vett2<tipo>::setX(tipo _x) {
    x=_x;
}


/* Assegna la seconda componente (y):
 */
template <class tipo>
void Vett2<tipo>::setY(tipo _y) {
    y=_y;
}



/** CLASSE Vett3: INTERROGAZIONE **/

/* Restituisce la prima componente (x):
 */
template <class tipo>
tipo Vett2<tipo>::getX(void) {
    return x;
}


/* Restituisce la seconda componente (y):
 */
template <class tipo>
tipo Vett2<tipo>::getY(void) {
    return y;
}




/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** MATRICE 3x3: CLASSE Matr3x3
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE Matr3x3: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
template <class tipo>
Matr3x3<tipo>::Matr3x3(void) {
    //Prima riga
    a11=0;
    a12=0;
    a13=0;
    //Seconda riga
    a21=0;
    a22=0;
    a23=0;
    //Terza riga
    a31=0;
    a32=0;
    a33=0;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE Matr3x3: ASSEGNAMENTO **/

/* Assegna tutte le componenti:
 */
template <class tipo>
void Matr3x3<tipo>::set(tipo _a11, tipo _a12, tipo _a13,
                      tipo _a21, tipo _a22, tipo _a23,
                      tipo _a31, tipo _a32, tipo _a33) {
    //Prima riga
    a11=_a11;
    a12=_a12;
    a13=_a13;
    //Seconda riga
    a21=_a21;
    a22=_a22;
    a23=_a23;
    //Terza riga
    a31=_a31;
    a32=_a32;
    a33=_a33;
}


/* Assegna ogni componente - prima riga:
 */
template <class tipo>
void Matr3x3<tipo>::set11(tipo _a11) {
    a11=_a11;
}

template <class tipo>
void Matr3x3<tipo>::set12(tipo _a12) {
    a12=_a12;
}

template <class tipo>
void Matr3x3<tipo>::set13(tipo _a13) {
    a13=_a13;
}


/* Assegna ogni componente - seconda riga:
 */
template <class tipo>
void Matr3x3<tipo>::set21(tipo _a21) {
    a21=_a21;
}

template <class tipo>
void Matr3x3<tipo>::set22(tipo _a22) {
    a22=_a22;
}

template <class tipo>
void Matr3x3<tipo>::set23(tipo _a23) {
    a23=_a23;
}


/* Assegna ogni componente - terza riga:
 */
template <class tipo>
void Matr3x3<tipo>::set31(tipo _a31) {
    a31=_a31;
}

template <class tipo>
void Matr3x3<tipo>::set32(tipo _a32) {
    a32=_a32;
}

template <class tipo>
void Matr3x3<tipo>::set33(tipo _a33) {
    a33=_a33;
}



/** CLASSE Matr3x3: INTERROGAZIONE **/

/* Restituisce una componente - prima riga:
 */
template <class tipo>
tipo Matr3x3<tipo>::get11(void) {
    return a11;
}

template <class tipo>
tipo Matr3x3<tipo>::get12(void) {
    return a12;
}

template <class tipo>
tipo Matr3x3<tipo>::get13(void) {
    return a13;
}


/* Restituisce una componente - seconda riga:
 */
template <class tipo>
tipo Matr3x3<tipo>::get21(void) {
    return a21;
}

template <class tipo>
tipo Matr3x3<tipo>::get22(void) {
    return a22;
}

template <class tipo>
tipo Matr3x3<tipo>::get23(void) {
    return a23;
}


/* Restituisce una componente - terza riga:
 */
template <class tipo>
tipo Matr3x3<tipo>::get31(void) {
    return a31;
}

template <class tipo>
tipo Matr3x3<tipo>::get32(void) {
    return a32;
}

template <class tipo>
tipo Matr3x3<tipo>::get33(void) {
    return a33;
}




/** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **
 ** MATRICE 4x4: CLASSE Matr4x4
 **
 ** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
 **/


/** CLASSE Matr4x4: COSTRUTTORE & DISTRUTTORE **/

/* Costruttore:
 * - inizializza le componenti.
 */
template <class tipo>
Matr4x4<tipo>::Matr4x4(void) {
    //Prima riga
    a11=0;
    a12=0;
    a13=0;
    a14=0;
    //Seconda riga
    a21=0;
    a22=0;
    a23=0;
    a24=0;
    //Terza riga
    a31=0;
    a32=0;
    a33=0;
    a34=0;
    //Terza riga
    a41=0;
    a42=0;
    a43=0;
    a44=0;
}


/* Distruttore: (per memoria)
 * - nothing to do.
 */



/** CLASSE Matr4x4: ASSEGNAMENTO **/

/* Assegna tutte le componenti:
 */
template <class tipo>
void Matr4x4<tipo>::set(tipo _a11, tipo _a12, tipo _a13, tipo _a14,
                         tipo _a21, tipo _a22, tipo _a23, tipo _a24,
                         tipo _a31, tipo _a32, tipo _a33, tipo _a34,
                         tipo _a41, tipo _a42, tipo _a43, tipo _a44) {
    //Prima riga
    a11=_a11;
    a12=_a12;
    a13=_a13;
    a14=_a14;
    //Seconda riga
    a21=_a21;
    a22=_a22;
    a23=_a23;
    a24=_a24;
    //Terza riga
    a31=_a31;
    a32=_a32;
    a33=_a33;
    a34=_a34;
    //Terza riga
    a41=_a41;
    a42=_a42;
    a43=_a43;
    a44=_a44;
}


/* Assegna ogni componente - prima riga:
 */
template <class tipo>
void Matr4x4<tipo>::set11(tipo _a11) {
    a11=_a11;
}

template <class tipo>
void Matr4x4<tipo>::set12(tipo _a12) {
    a12=_a12;
}

template <class tipo>
void Matr4x4<tipo>::set13(tipo _a13) {
    a13=_a13;
}

template <class tipo>
void Matr4x4<tipo>::set14(tipo _a14) {
    a14=_a14;
}


/* Assegna ogni componente - seconda riga:
 */
template <class tipo>
void Matr4x4<tipo>::set21(tipo _a21) {
    a21=_a21;
}

template <class tipo>
void Matr4x4<tipo>::set22(tipo _a22) {
    a22=_a22;
}

template <class tipo>
void Matr4x4<tipo>::set23(tipo _a23) {
    a23=_a23;
}

template <class tipo>
void Matr4x4<tipo>::set24(tipo _a24) {
    a24=_a24;
}


/* Assegna ogni componente - terza riga:
 */
template <class tipo>
void Matr4x4<tipo>::set31(tipo _a31) {
    a31=_a31;
}

template <class tipo>
void Matr4x4<tipo>::set32(tipo _a32) {
    a32=_a32;
}

template <class tipo>
void Matr4x4<tipo>::set33(tipo _a33) {
    a33=_a33;
}

template <class tipo>
void Matr4x4<tipo>::set34(tipo _a34) {
    a34=_a34;
}


/* Assegna ogni componente - quarta riga:
 */
template <class tipo>
void Matr4x4<tipo>::set41(tipo _a41) {
    a41=_a41;
}

template <class tipo>
void Matr4x4<tipo>::set42(tipo _a42) {
    a42=_a42;
}

template <class tipo>
void Matr4x4<tipo>::set43(tipo _a43) {
    a43=_a43;
}

template <class tipo>
void Matr4x4<tipo>::set44(tipo _a44) {
    a44=_a44;
}



/** CLASSE Matr4x4: INTERROGAZIONE **/

/* Restituisce una componente - prima riga:
 */
template <class tipo>
tipo Matr4x4<tipo>::get11(void) {
    return a11;
}

template <class tipo>
tipo Matr4x4<tipo>::get12(void) {
    return a12;
}

template <class tipo>
tipo Matr4x4<tipo>::get13(void) {
    return a13;
}

template <class tipo>
tipo Matr4x4<tipo>::get14(void) {
    return a14;
}


/* Restituisce una componente - seconda riga:
 */
template <class tipo>
tipo Matr4x4<tipo>::get21(void) {
    return a21;
}

template <class tipo>
tipo Matr4x4<tipo>::get22(void) {
    return a22;
}

template <class tipo>
tipo Matr4x4<tipo>::get23(void) {
    return a23;
}

template <class tipo>
tipo Matr4x4<tipo>::get24(void) {
    return a24;
}


/* Restituisce una componente - terza riga:
 */
template <class tipo>
tipo Matr4x4<tipo>::get31(void) {
    return a31;
}

template <class tipo>
tipo Matr4x4<tipo>::get32(void) {
    return a32;
}

template <class tipo>
tipo Matr4x4<tipo>::get33(void) {
    return a33;
}

template <class tipo>
tipo Matr4x4<tipo>::get34(void) {
    return a34;
}


/* Restituisce una componente - quarta riga:
 */
template <class tipo>
tipo Matr4x4<tipo>::get41(void) {
    return a41;
}

template <class tipo>
tipo Matr4x4<tipo>::get42(void) {
    return a42;
}

template <class tipo>
tipo Matr4x4<tipo>::get43(void) {
    return a43;
}

template <class tipo>
tipo Matr4x4<tipo>::get44(void) {
    return a44;
}

#endif // VETTORI_CPP_INCLUDED
