#ifndef VETTORI_H_INCLUDED
#define VETTORI_H_INCLUDED

//#include <iostream>
#include "Tipi.h"


using namespace std;



/** CLASSI PER VETTORI: Vett4 **/

/* Questa classe rappresenta un vettore con 4 componenti (x,y,z,w):
 */
template <class tipo>
class Vett4 {
    public:
        //Costruttore e distruttore
        Vett4(void);
        Vett4(tipo _x, tipo _y, tipo _z, tipo _w);
        ~Vett4(void) { };
        //Assegna il valore
        void set(tipo _x, tipo _y, tipo _z, tipo _w); //Tutte e quattro le componenti
        void setX(tipo _x); //Solo x
        void setY(tipo _y); //Solo y
        void setZ(tipo _z); //Solo z
        void setW(tipo _w); //Solo w
        //Restituisce il valore
        tipo getX(void); //Solo x
        tipo getY(void); //Solo y
        tipo getZ(void); //Solo z
        tipo getW(void); //Solo w

    private:
        tipo x, y, z, w;
};



/** CLASSI PER VETTORI: Vett3 **/

/* Questa classe rappresenta un vettore con 3 componenti (x,y,z):
 */
template <class tipo>
class Vett3 {
    public:
        //Costruttore e distruttore
        Vett3(void);
        Vett3(tipo _x, tipo _y, tipo _z);
        ~Vett3(void) { };
        //Assegna il valore
        void set(tipo _x, tipo _y, tipo _z); //Tutte e tre le componenti
        void setX(tipo _x); //Solo x
        void setY(tipo _y); //Solo y
        void setZ(tipo _z); //Solo z
        //Restituisce il valore
        tipo getX(void); //Solo x
        tipo getY(void); //Solo y
        tipo getZ(void); //Solo z

    private:
        tipo x, y, z;
};



/** CLASSI PER VETTORI: Vett2 **/

/* Questa classe rappresenta un vettore con 2 componenti (x,y):
 */
template <class tipo>
class Vett2 {
    public:
        //Costruttore e distruttore
        Vett2(void);
        Vett2(tipo _x, tipo _y);
        ~Vett2(void) { };
        //Assegna il valore
        void set(tipo _x, tipo _y); //Tutte e due le componenti
        void setX(tipo _x); //Solo x
        void setY(tipo _y); //Solo y
        //Restituisce il valore
        tipo getX(void); //Solo x
        tipo getY(void); //Solo y

    private:
        tipo x, y;
};



/** CLASSI PER MATRICI: Matr3x3 **/

/* Questa classe rappresenta una matrice 3x3:
 */
template <class tipo>
class Matr3x3 {
    public:
        //Costruttore e distruttore
        Matr3x3(void);
        ~Matr3x3(void) { };
        //Assegna il valore a tutte le componenti
        void set(tipo _a11, tipo _a12, tipo _a13,
                  tipo _a21, tipo _a22, tipo _a23,
                  tipo _a31, tipo _a32, tipo _a33);
        //Assegna il valore: prima riga
        void set11(tipo _a11);
        void set12(tipo _a12);
        void set13(tipo _a13);
        //Assegna il valore: seconda riga
        void set21(tipo _a21);
        void set22(tipo _a22);
        void set23(tipo _a23);
        //Assegna il valore: terza riga
        void set31(tipo _a31);
        void set32(tipo _a32);
        void set33(tipo _a33);
        //Restituisce il valore: prima riga
        tipo get11(void);
        tipo get12(void);
        tipo get13(void);
        //Restituisce il valore: seconda riga
        tipo get21(void);
        tipo get22(void);
        tipo get23(void);
        //Restituisce il valore: terza riga
        tipo get31(void);
        tipo get32(void);
        tipo get33(void);

    private:
        tipo a11, a12, a13;
        tipo a21, a22, a23;
        tipo a31, a32, a33;
};



/** CLASSI PER MATRICI: Matr4x4 **/

/* Questa classe rappresenta una matrice 3x3:
 */
template <class tipo>
class Matr4x4 {
    public:
        //Costruttore e distruttore
        Matr4x4(void);
        ~Matr4x4(void) { };
        //Assegna il valore a tutte le componenti
        void set(tipo _a11, tipo _a12, tipo _a13, tipo _a14,
                  tipo _a21, tipo _a22, tipo _a23, tipo _a24,
                  tipo _a31, tipo _a32, tipo _a33, tipo _a34,
                  tipo _a41, tipo _a42, tipo _a43, tipo _a44);
        //Assegna il valore: prima riga
        void set11(tipo _a11);
        void set12(tipo _a12);
        void set13(tipo _a13);
        void set14(tipo _a14);
        //Assegna il valore: seconda riga
        void set21(tipo _a21);
        void set22(tipo _a22);
        void set23(tipo _a23);
        void set24(tipo _a24);
        //Assegna il valore: terza riga
        void set31(tipo _a31);
        void set32(tipo _a32);
        void set33(tipo _a33);
        void set34(tipo _a34);
        //Assegna il valore: quarta riga
        void set41(tipo _a41);
        void set42(tipo _a42);
        void set43(tipo _a43);
        void set44(tipo _a44);
        //Restituisce il valore: prima riga
        tipo get11(void);
        tipo get12(void);
        tipo get13(void);
        tipo get14(void);
        //Restituisce il valore: seconda riga
        tipo get21(void);
        tipo get22(void);
        tipo get23(void);
        tipo get24(void);
        //Restituisce il valore: terza riga
        tipo get31(void);
        tipo get32(void);
        tipo get33(void);
        tipo get34(void);
        //Restituisce il valore: quarta riga
        tipo get41(void);
        tipo get42(void);
        tipo get43(void);
        tipo get44(void);

    private:
        tipo a11, a12, a13, a14;
        tipo a21, a22, a23, a24;
        tipo a31, a32, a33, a34;
        tipo a41, a42, a43, a44;
};



#endif // VETTORI_H_INCLUDED
